#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/64_PGM/64_PYT/m02__Zadávání_jednoduchých_hodnot.py
"""
Kopie pasáží se záznamy komunikace se systémem realizovanými v IDLE
a uvedenými ve výpisech kapitoly: 2  Zadávání jednoduchých hodnot.

Co se v kapitole naučíte
Kapitola vám postupně vysvětlí, jak správně zapisovat číselné hodnoty
včetně komplexních čísel a jaké možnosti Python nabízí pro zadávání textů.
V průběhu výkladu ukáže nejčastější místa různých chyb.
Poté vám představí některé speciální hodnoty, vysvětlí, co to jsou literály,
a ukáže, jak se v Pythonu zapisují komentáře.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
from dbg import DBG
if DBG>0: print(f'===== Modul {__name__} ===== START')
############################################################################



#Výpis 2.1: Reakce na zadání velkého čísla
############################################################################
12345678901234567890123456789       # SYNC
# 12345678901234567890123456789
0.1234567890123456789
# 0.12345678901234568
#>>>



#Výpis 2.2: Zpřehlednění čísel vložením podtržítek
############################################################################
123_456_789_0_123_456_789_0_123_456_789
# 12345678901234567890123456789
0.123_456_789_012_345_678_9
# 0.12345678901234568
# >>>



#Výpis 2.3: Zadávání a zobrazování desetinných čísel
############################################################################
123_456_789_0_123_456_789_0_123_456_789.
# 1.2345678901234568e+28
123e-3
# 0.123
123.
# 123.0
123e3
# 123000.0
# >>>



#Výpis 2.4: Zadávání a zobrazování komplexních čísel
############################################################################
3+5j
# (3+5j)
7j+5
# (5+7j)
1 + 1J
# (1+1j)
# !# 1+j
# Traceback (most recent call last):
#  File "<pyshell#31>", line 1, in <module>
#    1+j
# NameError: name 'j' is not defined
2j      # SYNC
# 2j
0+3j
# 3j
# >>>



#Výpis 2.5:     Zápis čísel v alternativních číselných soustavách
############################################################################
0b1111_1111
# 255
0o377
# 255
0xFF
# 255
0o0123_4567
# 342391
0x0123_4567_89AB_BCDEF
# 1311768467463720431
-0b0010
# -2
#!# 0123
# SyntaxError: leading zeros in decimal integer literals are not permitted; use an 0o prefix for octal integers
#>>>



#Výpis 2.6: Zápis Zápis jednořádkového textu
############################################################################
"Text v uvozovkách"
# 'Text v uvozovkách'
'Text v apostrofech'        # SYNC
# 'Text v apostrofech'
"Potřebuji 'apostrof'"      # SYNC
# "Potřebuji 'apostrof'"
'Potřebuji "uvozovky"'      # SYNC
# 'Potřebuji "uvozovky"'
# >>>



#Výpis 2.7: Zápis víceřádkového textu
############################################################################
#!# "Neukončený text
# SyntaxError: EOL while scanning string literal
"""několikařádkový
text"""
# 'několikařádkový\ntext'
'''Jiný způsob
zápisu'
'''
# "Jiný způsob\nzápisu'\n"
#!# '''Musí být 'odděleny''''
# SyntaxError: EOL while scanning string literal
''''Apostrof'.'''
# "'Apostrof'."
""
# ''
# >>>



#Výpis 2.8: Zadání znaků pomocí escape sekvencí
############################################################################
'\007\x09\x0a\x0d\x22\x27'
#'\x07\t\n\r"\''
'\u263a'
#'☺'
'\N{ZOMBIE}\N{DEGREE CELSIUS}\N{WHITE SMILING FACE}\N{SPACE}'
#'\U0001f9df\u2103\u263a '
'\N{DEGREE CELSIUS}\N{WHITE SMILING FACE}'
#'℃☺'
'\N{WHITE SMILING FACE}' == '\u263a' == '☺'
#True



#Výpis 2.9: Reakce na použití objektů None a ... (Ellipsis)
############################################################################
None
...
# Ellipsis
# >>>



#Výpis 2.10: Komentáře
############################################################################
# Řádek obsahující jen komentář
#!# 0123   # Špatně zapsané číslo - počáteční nula je zakázaná
# SyntaxError: invalid token
"Jednořádkový text"    # Tento text lze okomentovat
# 'Jednořádkový text'
''' Víceřádkový    # Toto není komentář, ale součást textu
text'''
# ' Víceřádkový    # Toto není komentář, ale součást textu\ntext'
# Potřebujete-li vysvětlit něco složitějšího,
# musíte místo víceřádkového komentáře zadat sérii
# jednořádkových komentářů
# >>>



#Výpis 2.Y: Popisek
############################################################################
if DBG>0: print(f'===== Modul {__name__} ===== STOP')
