#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/64_PGM/64_PYT/m06__Jednoduché_příkazy.py
"""
Kopie pasáží se záznamy komunikace se systémem realizovanými v IDLE
a uvedenými ve výpisech kapitoly:  6  Jednoduché příkazy.

Co se v kapitole naučíte
Tato kapitola vám představí několik základních příkazů: příkaz pass,
příkaz tvořený výrazem, přiřazovací příkaz, příkaz del a příkaz assert.
Současně probere možnost zadávat několik příkazů na řádku
a na závěr pak i základy formátování složených příkazů.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
from dbg import DBG
if DBG>0: print(f'===== Modul {__name__} ===== START')
############################################################################



#Výpis 6.1: Složené přiřazovací operátory
############################################################################
a = 1; b = 10; c = 100;
a <<= 3; a   #Ekvivalent: a = a << 3, tj. a = a * 2**3, tj. a = a * 8
# 8
c += b; c    #Ekvivalent: c = c + b = 100 + 10
# 110
b *= a + c; a, b, c     #Ekvivalent: b = b * (a + c) = 10 * (8 + 110)
# (8, 1180, 110)
# >>>



#Výpis 6.2: Použití příkazu del
############################################################################
a, b, c, (s:='String'), (t:=s)
# (8, 1180, 110, 'String', 'String')
del b, s
s
# Traceback (most recent call last):
#   File "<pyshell#198>", line 1, in <module>
#     s
# NameError: name 's' is not defined
a, c, t
(8, 110, 'String')
# >>>



#Výpis 6.3: Použití příkazu assert
############################################################################
__debug__
# True
assert 1 < 2
assert 1 > 2
# Traceback (most recent call last):
#   File "<pyshell#99>", line 1, in <module>
#     assert 1 > 2
# AssertionError
assert 1 > 2, 'Zprává popisující, co bylo očekáváno a nesplněno'
# Traceback (most recent call last):
#   File "<pyshell#101>", line 1, in <module>
#     assert 1 > 2, 'Zprává popisující, co bylo očekáváno a nesplněno'
# AssertionError: Zprává popisující, co bylo očekáváno a nesplněno
#!# __debug__ = False
# SyntaxError: cannot assign to __debug__
# >>>



#Výpis 6.4: Spuštění systému Python a aktivovaným a deaktivovaným příkazem
#           assert
############################################################################
# Microsoft Windows [Version 10.0.18362.239]
# (c) 2019 Microsoft Corporation. Všechna práva vyhrazena.

# P:\60_PGM\_SRC>python -O
# Python 3.8.0b2 (tags/v3.8.0b2:21dd01d, Jul  4 2019, 16:00:09) [MSC v.1916 64 bit (AMD64)] on win32
# Type "help", "copyright", "credits" or "license" for more information.
__debug__
# False
assert 1 > 2
exit()

# P:\60_PGM\_SRC>python
# Python 3.8.0b2 (tags/v3.8.0b2:21dd01d, Jul  4 2019, 16:00:09) [MSC v.1916 64 bit (AMD64)] on win32
# Type "help", "copyright", "credits" or "license" for more information.
__debug__
# True
assert 1 > 2
# Traceback (most recent call last):
#   File "<stdin>", line 1, in <module>
# AssertionError
exit()

# P:\60_PGM\_SRC>



#Výpis 6.5: Kontrola shodnosti odsazení příkazů
############################################################################
x = 1
#!#  x = 2

# SyntaxError: unexpected indent
#>>>



#Výpis 6.Y: Popisek
############################################################################
if DBG>0: print(f'===== Modul {__name__} ===== STOP')
