#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/64_PGM/64_PYT/m07__Moduly.py
"""
Kopie pasáží se záznamy komunikace se systémem realizovanými v IDLE
a uvedenými ve výpisech kapitoly:  7  Moduly.

Co se v kapitole naučíte
Tato kapitola vám vysvětlí, co to jsou moduly, jak do nich ukládat
zdrojový kód a jak s nimi pracovat v programu.
Naučíte se importovat modul, s nímž potřebujete pracovat.
Zjistíte, jak v případě potřeby znovu načíst již importovaný modul
a hlavně jaké záludnosti na vás při reimportu modulu čekají.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
from dbg import DBG
if DBG>0: print(f'===== Modul {__name__} ===== START')
############################################################################



# Výpis 7.1: Importování modulů
############################################################################
#!# turtle.Turtle()   # Před importem modulu jsou jeho atributy nepoužitelné
# Traceback (most recent call last):
#   File "<pyshell#1>", line 1, in <module>
#     turtle.Turtle()   # Před importem modulu jsou jeho atributy nepoužitelné
# NameError: name 'turtle' is not defined
import turtle
t = turtle.Turtle()
t.forward(50)
t.left(90); t.forward(50)
# >>>



# Výpis 7.2: Přejmenování importovaného modulu
############################################################################
korytnačka = turtle          # Korytnačka = želva slovensky
tk = korytnačka.Turtle()     # Nová želva, kvalifikujeme názvem proměnné
tk.left(90); tk.forward(50)  # Želva nakreslila čáru směrem vzhůru
# >>>
import turtle as želva  # Nevytváří se nový objekt, použije se stávající
tz = želva.Turtle()          # Třetí želva
tz.forward(-100)             # Přesune se o 100 bodů vlevo
# >>>
turtle; korytnačka; želva    #Vypisují se podpisy odkazovaných objektů
# <module 'turtle' from 'Ca:\\_PGM\\Python3x\\lib\\turtle.py'>
# <module 'turtle' from 'Ca:\\_PGM\\Python3x\\lib\\turtle.py'>
# <module 'turtle' from 'Ca:\\_PGM\\Python3x\\lib\\turtle.py'>
(turtle is korytnačka) and (turtle is želva)  # Jsou objekty identické?
# True
# >>>



# Výpis 7.3: Import zadaných objektů ze zadaného modulu
############################################################################
from math import sin, cos, pi as PI, tau as TAU    # τ = 2 * π
sin(PI/2), cos(PI), cos(TAU)
# (1.0, -1.0, 1.0)
#!# math
# Traceback (most recent call last):
#   File "<pyshell#2>", line 1, in <module>
#     math
# NameError: name 'math' is not defined
import math
math
# <module 'math' (built-in)>
math.tan(PI/4)
# 0.9999999999999999
# >>>



# Výpis 7.4: Použitelnost proměnné s odkazem na modul
############################################################################
import math as m   # Do proměnné m se uloží odkaz na modul
m
# <module 'math' (built-in)>
m.tan(PI/4)        # Tuto proměnnou můžeme využít ke kvalifikaci
# 0.9999999999999999
#!# from m import tan  # Nemůžeme ji však využít pro další import
# Traceback (most recent call last):
#   File "<pyshell#5>", line 1, in <module>
#     from m import tan
# ModuleNotFoundError: No module named 'm'
# >>>



# Výpis 7.5: Import všech objektů ze zadaného modulu
############################################################################
#!# tan(PI/4)
# Traceback (most recent call last):
#   File "<pyshell#4>", line 1, in <module>
#     tan(PI/4)
# NameError: name 'tan' is not defined
from math import *
tan(PI/4)
# 0.9999999999999999
# >>>



#Výpis 7.6: Modul builtins
############################################################################
#!# builtins
# Traceback (most recent call last):
#   File "<pyshell#8>", line 1, in <module>
#     builtins
# NameError: name 'builtins' is not defined
import builtins
builtins
# <module 'builtins' (built-in)>
int, builtins.int
# (<class 'int'>, <class 'int'>)
int is builtins.int
# True
# >>>



#Výpis 7.7: Modul m07a_Modul sloužící k demonstraci chování Pythonu
#           při zavádění modulu
############################################################################

"""Tento modul je ve vlastním souboru"""



#Výpis 7.8: Import modulu m07a_Modul
############################################################################
import m07a_Modul as m
# ===== Modul m07a_Modul ===== START
# Hodnoty výrazových příkazů se nezobrazují
# Chcete-li zobrazit nějakou hodnotu, musíte ji explicitně vytisknout
#    První verze 123456 Stále první verze
# ===== Modul m07a_Modul ===== STOP
m.text, m.num, m.txt2, m._np
# ('První verze', 123456, 'Stále první verze', 'Neveřejné')
help(m)
# Help on module m07a_Modul:
#
# NAME
#     m07a_Modul
#
# DESCRIPTION
#     Úvodní modul demonstrující základní pravidla pro tvorbu modulů,
#     jejich zavádění a následnou práci s nimi.
#     Modul se omezuje na definici proměnných a provedení několika příkazů.
#
# DATA
#     num = 123456
#     text = 'První verze'
#     txt2 = 'Stále první verze'
#
# FILE
#     p:\64_pgm\64_pyt\m07a_modul.py
#
#
m
# <module 'm07a_Modul' from 'P:\\64_PGM\\64_PYT\\m07a_Modul.py'>
#!# m07a_Modul
# Traceback (most recent call last):
#   File "<pyshell#26>", line 1, in <module>
#     m07a_Modul
# NameError: name 'm07a_Modul' is not defined
import m07a_Modul
m07a_Modul
# <module 'm07a_Modul' from 'P:\\64_PGM\\64_PYT\\m07a_Modul.py'>
import m07a_Modul as mod
mod
# <module 'm07a_Modul' from 'P:\\64_PGM\\64_PYT\\m07a_Modul.py'>
# >>>



#Výpis 7.9: Přímý import atributů
############################################################################
#!# text, num, txt2
# Traceback (most recent call last):
#   File "<pyshell#31>", line 1, in <module>
#     text, num, txt2
# NameError: name 'text' is not defined
from m07a_Modul import *
text, num, txt2
# ('První verze', 123456, 'Stále první verze')
#!# _np
# Traceback (most recent call last):
#   File "<pyshell#34>", line 1, in <module>
#     _np
# NameError: name '_np' is not defined
from m07a_Modul import _np
_np
# 'Neveřejné'
# >>>



#Výpis 7.10: Nové načtení modulu m07_01_Modul
############################################################################
from m07a_Modul import *;   text, num, txt2;   m.text, m.num, m.txt2
# ('První verze', 123456, 'Stále první verze')
# ('První verze', 123456, 'Stále první verze')
from importlib import reload
mm = reload(m)
# ===== Modul m07a_Modul ===== START
# Hodnoty výrazových příkazů se nezobrazují
# Chcete-li zobrazit nějakou hodnotu, musíte ji explicitně vytisknout
#    Druhá verze 23456 Stále druhá verze
# ===== Modul m07a_Modul ===== STOP
m is mm, mm
# (True, <module 'm07a_Modul' from 'P:\\64_PGM\\64_PYT\\m07a_Modul.py'>)
# >>>



#Výpis 7.11: „Neaktualizace“ přímo importovaných odkazů
############################################################################
text, num, txt2;   m.text, m.num, m.txt2
# ('První verze', 123456, 'Stále první verze')
# ('Druhá verze', 23456, 'Stále druhá verze')
from m07a_Modul import *;   text, num, txt2;   m.text, m.num, m.txt2
# ('Druhá verze', 23456, 'Stále druhá verze')
# ('Druhá verze', 23456, 'Stále druhá verze')
# >>>



#Výpis 7.12: Opětovné načtení verze s chybou
############################################################################
reload(m)
# ===== Modul m07a_Modul ===== START
# Původní hodnoty: Druhá verze 23456 Stále druhá verze
# Traceback (most recent call last):
#   File "<pyshell#50>", line 1, in <module>
#     mm = reload(m)
#   File "C:\_PGM\Python\Python39\lib\importlib\__init__.py", line 169, in reload
#     _bootstrap._exec(spec, module)
#   File "<frozen importlib._bootstrap>", line 613, in _exec
#   File "<frozen importlib._bootstrap_external>", line 790, in exec_module
#   File "<frozen importlib._bootstrap>", line 228, in _call_with_frames_removed
#   File "P:\64_PGM\64_PYT\m07a_Modul.py", line 14, in <module>
#     num  = 3_456 / 0
# ZeroDivisionError: division by zero
m.text, m.num, m.txt2
# ('Třetí verze', 23456, 'Stále druhá verze')
# >>>



#Výpis 7.13: Import modulu posixpath nebo ntpath zprostředkovaný modulem os
############################################################################
import sys   #$ SYNC ???
_names = sys.builtin_module_names   # Názvy všech přeložených modulů

if 'posix' in _names:   # Modul posix je definován v Unix-like systémech
    import posixpath as path
elif 'nt' in _names:    # Modul nt je definován pro Windows
    import ntpath as path
else:
    raise ImportError('no os specific module found')



#Výpis 7.14: Prověrka zprostředkování importu
############################################################################
import os
os.path;   os.path.join
# <module 'ntpath' from 'C:\\_PGM\\Python\\Python39\\lib\\ntpath.py'>
# <function join at 0x0000024E466CFA60>
# >>>



#Výpis 7.Y: Popisek
############################################################################
if DBG>0: print(f'===== Modul {__name__} ===== STOP')
