#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ ó
#P:/64_PGM/64_PYT/m08__Definice_funkcí.py
"""
Kopie pasáží se záznamy komunikace se systémem realizovanými v IDLE
a uvedenými ve výpisech kapitoly:  8  Definice funkcí.

Co se v kapitole naučíte
Tato kapitola vám nejprve vysvětlí, jak definovat jednoduché funkce,
probere význam a použití parametrů a argumentů včetně možnosti zadání
jejich implicitních hodnot. Naučí vás definovat funkce vracející hodnotu
a upozorní ne nebezpečí funkcí s vedlejším efektem.
Ukáže vám, jak se dají argumenty funkce a její návratové hodnoty anotovat,
a předvede jak definovat funkce v samostatném modulu.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
from dbg import DBG
if DBG>0: print(f'===== Modul {__name__} ===== START')
############################################################################



#Výpis 8.1: Definice bezparametrické funkce
############################################################################
f = "Zatím nic";   f
# 'Zatím nic'
def f(): 'Nedoporučovaný zápis'; print('Jednořádková definice funkce')

f
# <function f at 0x000001AED2FB1310>
f()             #SYNC
# Jednořádková definice funkce
help(f)
# Help on function f in module __main__:
#
# f()          #SYNC #SYNC
#     Nedoporučovaný zápis

def f():
    """Funkce definovaná doporučovaným způsobem."""
    print('Funkce definovaná na více řádcích:', f)
    print('Všechny příkazy těla musejí být shodně odsazeny')


f()
# Funkce definovaná na více řádcích: <function f at 0x000001AED2FA2160>
# Všechny příkazy těla musejí být shodně odsazeny
f = 'Teď je tu opět text'; f
# 'Teď je tu opět text'
f()
# Traceback (most recent call last):
#   File "<pyshell#85>", line 1, in <module>
#     f()
# TypeError: 'str' object is not callable
# >>>



#Výpis 8.2: Přisazení definice funkce v interaktivním režimu
############################################################################
# >>> \
def přisazená():
    """Demo přisazené definice v interaktivním režimu."""
    txt1 = ('U delších definic složených příkazů (např. funkcí)\n'
            'budu umisťovat na řádek s výzvou samostatné zpětné lomítko,\n'
            'jak je to předvedeno na příkladu této funkce.\n')
    txt2 = '''Nechceme-li používat víceřádkový string, jehož pokračovací
řádky se musejí umisťovat od levého okraje, čímž ruší vzhled programu,
musíme skupinu navazujících stringů uzavřít do závorek,'''
    txt3 = 'anebo zakončovat jednotlivé řádky zpětným lomítkem,\n' \
           'jak je to předvedeno v tomto přiřazovacím příkazu.'
    print(txt1)
    print(txt2)
    print(txt3)

# >>>



#Výpis 8.3: Dynamická povaha jazyka při definici a volání funkcí
############################################################################
#!# varX
# Traceback (most recent call last):
#   File "<pyshell#17>", line 1, in <module>
#     varX
# NameError: name 'varX' is not defined
def fceX():
    """V definici funkce lze použít i dosud neexistující proměnnou.
    Důležité je, aby existovala v době, kdy bude funkce zavolána.
    """
    print('Proměnná varX =', varX)

varX = 'Žiju'   # Proměnná právě vznikla
fceX()          # Při volání funkce překladač zjistí, že proměnná existuje
# Proměnná varX = Žiju
varX = 'Končím'
fceX()          # Mezi voláními proměnná změnila hodnotu
# Proměnná varX = Končím
del varX        # Proměnná byla odstraněna
fceX()          # Nyní skončí volání funkce chybou
# Traceback (most recent call last):
#   File "<pyshell#47>", line 1, in <module>
#     fceX()          # Nyní skončí volání funkce chybou
#   File "<pyshell#41>", line 5, in fceX
#     print('Proměnná varX =', varX)
# NameError: name 'varX' is not defined
#!# def fceE(): "Funkce se syntaktickou chybou"; a=01
# SyntaxError: leading zeros in decimal integer literals are not permitted; use an 0o prefix for octal integers
#!# fceE()
# Traceback (most recent call last):
#   File "<pyshell#49>", line 1, in <module>
#     fceE()
# NameError: name 'fceE' is not defined
# >>>



#Výpis 8.4: Definice a volání funkcí s parametry
############################################################################
def dhb(n):
    """Vytiskne zadané číslo v soustavách o základu 10, 16 a 2."""
    print(n, hex(n), bin(n))

dhb(999)
# 999 0x3e7 0b1111100111
# >>>



#Výpis 8.5: Definice funkce s lokálními proměnnými
############################################################################
def objemVálce(průměr, výška):
    """Vytiskne objem válce o zadaném průměru a výšce."""
    základna = 3.1415926 * průměr * průměr / 4
    objem    = základna * výška
    print ('Objem válce o průměru', průměr, 'a výšce', výška, 'je', objem)

# >>>



#Výpis 8.6: Volání funkcí s parametry
############################################################################
objemVálce(1, 2)   # Při zadávání argumentů musím dodržet pořadí
# Objem válce o průměru 1 a výšce 2 je 1.5707963
objemVálce(výška=2, průměr=1)   # Nebo je zadávat pojmenované
# Objem válce o průměru 1 a výšce 2 je 1.5707963
#!# objemVálce(průměr=1, 2)         # Musí se začít pozičními
# SyntaxError: positional argument follows keyword argument
objemVálce(1, výška=2)
# Objem válce o průměru 1  a výšce  2  je  1.5707963
objemVálce(2, průměr=1)         # Poziční nelze přeskakovat
# Traceback (most recent call last):
#   File "<pyshell#23>", line 1, in <module>
#     objemVálce(2, průměr=1)
# TypeError: objemVálce() got multiple values for argument 'průměr'
def posKeyDemo(p1, p2, p3, p4, p5):
    """Pomocná funkce pro demonstraci práce s pozičními parametry."""
    print(p1, p2, p3, p4, p5)

posKeyDemo('a1', 'a2', 'a3', 'a4', 'a5', )
# a1 a2 a3 a4 a5
posKeyDemo(10, 20, p5=55, p3=33, p4=44)
# 10 20 33 44 55
# >>>



#Výpis 8.7: Funkce s povinně pojmenovanými argumenty
############################################################################
def rozměr(název, *, délka, šířka, výška):
    """Vytiskne zadaný název a rozměry objektu. Ukázka funkce,
    jejíž některé argumenty jsou povinně zadávány jako pojmenované.
    """
    print(název, "- Délka:", délka, "- Šířka:", šířka, "- Výška:", výška)

rozměr('stůl', výška=75, délka=120, šířka=60)
# stůl - Délka: 120 - Šířka: 60 - Výška: 75
rozměr('deska', 100, 50, 2)
# Traceback (most recent call last):
#   File "<pyshell#35>", line 1, in <module>
#     rozměr('deska', 100, 50, 2)
# TypeError: rozměr() takes 1 positional argument but 4 were given
# >>>



#Výpis 8.8: Funkce s povinně pozičními argumenty
############################################################################
def positional(p1, p2, /, p3):
    """Funkce, jejíž první dva argumenty musí být zadány jako poziční."""
    print(p1, p2, p3)

positional(1, 2, 3)
# 1 2 3
positional(11, 22, p3=33)
# 11 22 33
positional(111, p2=222, p3=333)
# Traceback (most recent call last):
#   File "<pyshell#28>", line 1, in <module>
#     positional(111, p2=222, p3=333)
# TypeError: positional() got some positional-only arguments passed as keyword arguments: 'p2'
# >>>



#Výpis 8.9: Funkce s různými kombinacemi povinných parametrů
############################################################################
def fpp (p1, p2, p3, p4, /):
    """Funkce deklarující pouze poziční parametry."""
    print("p1:", p1, "# p2:", p2, "# p3:", p3, "# p4:", p4)

fpp(10, 20, 30, 40)
#p1: 10 # p2: 20 # p3: 30 # p4: 40
# >>> \
def fnn (*, n1, n2, n3, n4):
    """Funkce deklarující pouze pojmenované parametry."""
    print("n1:", n1, "# n2:", n2, "# n3:", n3, "# n4:", n4)

fnn(n1=100, n2=200, n3=300, n4=400)
# n1: 100 # n2: 200 # n3: 300 # n4: 400
# >>> \
def fpn (p1, p2, /, *, n1, n2):
    """Funkce deklarující dva jen poziční a dva jen pojmenované parametry."""
    print("p1:", p1, "# p2:", p2, "# n1:", n1, "# n2:", n2)

fpn(1, 2, n1=101, n2=202)
# p1: 1 # p2: 2 # n1: 101 # n2: 202
# >>> \
def fpgn (p1, p2, /, g1, g2, *, n1, n2):
    """Funkce požadující všechny tři druhy argumentů:
    dva jen poziční, dva obecné a dva jen pojmenované.
    """
    print("p1:", p1, "# p2:", p2, "# g1:", g1, "# g2:", g2,
          "# n1:", n1, "# n2:", n2)

fpgn(1, 2, 10, 20, n1=110, n2=220)
# p1: 1 # p2: 2 # g1: 10 # g2: 20 # n1: 110 # n2: 220
fpgn(1, 2, 10, g2=21, n1=111, n2=221)
# p1: 1 # p2: 2 # g1: 10 # g2: 21 # n1: 111 # n2: 221
fpgn(1, 2, g1=12, g2=22, n1=112, n2=222)
# p1: 1 # p2: 2 # g1: 12 # g2: 22 # n1: 112 # n2: 222
# >>>



#Výpis 8.10: Volání funkce print() s vlastní hodnotou implicitního argumentu
############################################################################
def dhb(n):
    """Vytiskne zadané číslo v soustavách o základu 10, 16 a 2."""
    print(n, hex(n), bin(n), sep=' = ')

dhb(999)
# 999 = 0x3e7 = 0b1111100111
# >>>



#Výpis 8.11: Definice funkce se dvěma implicitními argumenty a možnosti jejího volání
############################################################################
def kruh(x, y, r=1, barva="černá"):
    """Ukázka funkce se dvěma implicitními argumenty."""
    print("x=", x, ", y=", y, ", r=", r, ", barva=", barva, sep='')

kruh(10, 20)
# x=10, y=20, r=1, barva=černá
kruh(11, 22, 33)
# x=11, y=22, r=33, barva=černá
kruh(1, 2, 3, 'modrá')
# x=1, y=2, r=3, barva=modrá
kruh(1.5, 2.7, barva='žlutá')
# x=1.5, y=2.7, r=1, barva=žlutá
# >>>



#Výpis 8.12: Konstantnost předdefinovaných hodnot
############################################################################
a = 1
def default(x = a): print('Hodnota x =', x)

default()
# Hodnota x = 1
a = 7;
default()
# Hodnota x = 1
default(5)
# Hodnota x = 5
# >>>



#Výpis 8.13: Funkce s vedlejším efektem
############################################################################
print('"Vrátí" nic:', kruh(10, 20))   #Vedlejší efekt
# x=10, y=20, r=1, barva=černá
# "Vrátí" nic: None
# >>>



#Výpis 8.14: Definice a použití funkcí vracejících hodnotu
############################################################################
def fahr2cel(fahr):
    """Převede stupně Fahrenheita na stupně Celsia."""
    return 5 / 9 * (fahr - 32)

def fahr2celsLV(fahr):
    """Stejná funkcionalita, používá lokální proměnné."""
    from0 = fahr - 32
    koef  = 5/9
    cels  = koef * from0
    return cels

print('Papír hoří při', round(fahr2cel(451)), '\N{DEGREE CELSIUS}')
# Papír hoří při 233 ℃
# >>>



#Výpis 8.15: Nepoužitelnost přetěžování funkcí
############################################################################
def a(): pass

def a(b): pass

a()
# Traceback (most recent call last):
#   File "<pyshell#211>", line 1, in <module>
#     a()
# TypeError: a() missing 1 required positional argument: 'b'
def krát(x, y) : return x * y

krát(3, 4);  krát(3, 'Čtyři')
# 12
# 'ČtyřiČtyřiČtyři'
# >>>



#Výpis 8.16: Anotace parametrů funkce, její návratové hodnoty a atributů modulu
############################################################################
def annFce(a:'něco', b, c:(1,10), d:int) -> str:
    """ Funkce demonstrující použití anotací."""
    return str(a) + str(b) + str(c) + str(d)

annFce(1, 2, 3, 4)
# '1234'
annFce.__annotations__
# {'a': 'něco', 'c': (1, 10), 'd': <class 'int'>, 'return': <class 'str'>}
ai:int = "špatně"
#!# import __main__   # Ten mohu importovat pouze v interaktivním režimu
#!# help(__main__)
# Help on module __main__:

# NAME
#     __main__

# FUNCTIONS
#     annFce(a: 'něco', b, c: (1, 10), d: int) -> str
#         Funkce demonstrující použití anotací.

# DATA
#     __annotations__ = {'ai': <class 'int'>}
#     ai = 'špatně'

# FILE
#     (built-in)


# >>>



#Výpis 8.17: Pravidla pro definice funkcí v modulu
############################################################################

"""Tento kód je v souboru m08a_Funkce_v_modulu.py"""



#Výpis 8.Y: Popisek
############################################################################
if DBG>0: print(f'===== Modul {__name__} ===== STOP')
