# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/64_PGM/64_PYT/m09__Pokročilé_rysy_funkcí.py
"""
Kopie pasáží se záznamy komunikace se systémem realizovanými v IDLE
a uvedenými ve výpisech kapitoly:  9  Pokročilé rysy funkcí.

Co se v kapitole naučíte
Tato kapitola je věnována pokročilým vlastnostem funkcí
a možnostem jejich použití.
Je určena pro programátory s alespoň základními zkušenostmi.
Naprostí začátečníci ji mohou přeskočit. Umístil jsem ji sem proto,
abyste měli související informace pohromadě, a využil jsem toho,
že k probrání těchto rysů není následně probíraná látka potřeba.

Kapitola vás postupně seznámí s problematikou jmenných prostorů
a lokality používaných proměnných, pohovoří o možnosti
definovat funkci uvnitř funkce, o funkcích vyšších řádů,
které mají za parametr funkci (nebo samy vracejí funkci),
a o některých dalších vlastnostech.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
from dbg import DBG
if DBG>0: print(f'===== Modul {__name__} ===== START')
############################################################################



#Výpis 9.1: Definice vnitřních funkcí
############################################################################
# >>> \
def vnější():
    print('Volána funkce vnější')
    def vnitřní1():
        print('  Volána funkce vnitřní1')
        def vnitřní2(): print('    Volána funkce vnitřní2')
        vnitřní2()
        print('  Funkce vnitřní1 končí')
    print('Budu volat vnitřní1')
    vnitřní1()
    print('Funkce vnější končí')

vnější()
# Volána funkce vnější
# Budu volat vnitřní1
#   Volána funkce vnitřní1
#     Volána funkce vnitřní2
#   Funkce vnitřní1 končí
# Funkce vnější končí
# >>>



#Výpis 9.2: Zakrytí globální proměnné stejnojmennou lokální
############################################################################
glo = 'globální'
def fce1(): print('glo = ', glo)

fce1()
# glo =  globální
def fce2(): glo = 'lokální'; print('glo = ', glo)

fce2()
# glo =  lokální
print('glo = ', glo)
# glo =  globální
#!# def fce3(): print(glo); glo  = 'lokální'

#!# fce3()
# Traceback (most recent call last):
#  File "<pyshell#44>", line 1, in <module>
#    fce3()
#  File "<pyshell#43>", line 1, in fce3
#    def fce3(): print(glo); glo  = 'lokální'
# UnboundLocalError: local variable 'glo' referenced before assignment
# >>>



#Výpis 9.3: Použití příkazu global
############################################################################
var1 = var2 = 'globální'
#!# var3
# Traceback (most recent call last):
#  File "<pyshell#7>", line 1, in <module>
#    var3
# NameError: name 'var3' is not defined
def fceg():
    """Demonstrace korektní modifikace globálních proměnných funkcí."""
    global var1, var3
    var1 = var2 = 'lokální';  var3 = 'Definovaná'
    print('Uvnitř: var1=', var1, ', var2=', var2, ', var3=', var3, sep='')

fceg()
# Uvnitř: var1=lokální, var2=lokální, var3=Definovaná
print('Vně: var1=', var1, ', var2=', var2, ', var3=', var3, sep='')
# Vně: var1=lokální, var2=globální, var3=Definovaná
# >>>



#Výpis 9.4: Použití příkazu nonlocal
############################################################################
# >>> \
def f1():
    """První úroveň - vnější funkce."""
    def f2():
        """Druhá úroveň - vnitřní funkce."""
        def f3():
            """Třetí úroveň - vnitřní funkce ve vnitřní funkci"""
            nonlocal v13, v23
            v13 += ' v třetí'
            v23 += ' v třetí'
            nonlocal v31, v32
            v31 =  'Třetí pro první'
            v32  = 'Třetí pro druhou'
            print('Ve třetí: v11=', v11, ', v12=', v12, ', v13=', v13,
                '\n          v23=', v23, ', v31=', v31, ', v32=', v32,
                sep='')
        nonlocal v12
        v23  = 'Druhá'  # Musíme definovat proměnné, které bude
        v32  = None     # vnitřní funkce deklarovat jako nonlocal
        v12 += ' v druhé'
        f3()
        print('Ve druhé: v11=', v11, ', v12=', v12, ', v13=', v13,
            '\n          v23=', v23, ', v31=', v31, ', v32=', v32, sep='')
    v11 = v12 = v13 = 'První'   # Zde definujeme všechny, aby byly
    v23 = v31 = v32 = None      # viditelné a použitelné v příkazu tisku
    f2()
    print('V  první: v11=', v11, ', v12=', v12, ', v13=', v13,
        '\n          v23=', v23, ', v31=', v31, ', v32=', v32, sep='')

f1()
# Ve třetí: v11=První, v12=První, v13=První v třetí
#          v23=Druhá v třetí, v31=Třetí pro první, v32=Třetí pro druhou
# Ve druhé: v11=První, v12=První v druhé, v13=První v třetí
#          v23=Druhá v třetí, v31=Třetí pro první, v32=Třetí pro druhou
# V  první: v11=První, v12=První v druhé, v13=První v třetí
#          v23=None, v31=Třetí pro první, v32=None
# >>>



#Výpis 9.5: Demonstrace vnořeného volání funkcí
############################################################################
def kul(arg):
    """Vrátí argument zabalený do kulatých závorek."""
    print('==> Volána kul(', repr(arg), ')', sep='')
    ret = '(' + arg + ')'
    print('<== kul vrací:', repr(ret))
    return ret

def hra(arg):
    """Vrátí argument zabalený do hranatých závorek."""
    print('==> Volána hra(', repr(arg), ')', sep='')
    ret = '[' + arg + ']'
    print('<== hra() vrací:', repr(ret))
    return ret

def lom(arg):
    """Vrátí argument zabalený do lomených závorek."""
    print('==> Volána lom(', repr(arg), ')', sep='')
    ret = '<' + arg + '>'
    print('<== lom() vrací:', repr(ret))
    return ret

print('Nejdříve', hra(lom(kul("text"))), "pak", lom('potom'))
# ==> Volána kul('text')
# <== kul vrací: '(text)'
# ==> Volána lom('(text)')
# <== lom() vrací: '<(text)>'
# ==> Volána hra('<(text)>')
# <== hra() vrací: '[<(text)>]'
# ==> Volána lom('potom')
# <== lom() vrací: '<potom>'
# Nejdříve [<(text)>] pak <potom>
# >>>



#Výpis 9.6: Použití funkce vracející funkci
############################################################################
def actionF(operator):
    """Vrátí funkci realizující operaci zadanou argumentem."""
    def ADD(x, y):  # Sloučí podpisy argumentů
        result = str(x) + str(y)
        return result
    def MUL(n, s):  # Vrátí opakovací řetězec
        result = int(n) * str(s)
        return result
    def ERR(x, y):  # Vrátí chybovou zprávu
        return '### NEZNÁMÁ AKCE: «' + str(operator) + '» ###'
    return ADD if operator == '+'  else \
           MUL if operator == '*'  else \
           ERR

def actionL(operator):
    """Vrátí funkci realizující operaci zadanou argumentem."""
    return (lambda x, y: str(x) + str(y)) if operator == '+' \
      else (lambda a, b: int(a) * str(b)) if operator == '*' \
      else (lambda x, y: '### NEZNÁMÁ AKCE: «' + str(operator) + '» ###')

actionF('+')(1, 2)
# '12'
fx = actionL('*');  fx(3, 4)
# '444'
actionL(...)(5, 6)
# '### NEZNÁMÁ AKCE: «Ellipsis» ###'
# >>>



#Výpis 9.7: Použití atributů funkce
############################################################################
def countingFunction():
        countingFunction.count += 1
        print('Byla jsem zavolána', countingFunction.count, 'krát')

countingFunction.count = 0
countingFunction(); countingFunction(); countingFunction(); countingFunction()
# Byla jsem zavolána 1 krát
# Byla jsem zavolána 2 krát
# Byla jsem zavolána 3 krát
# Byla jsem zavolána 4 krát
# >>>



#Výpis 9.8: Nelokální proměnné a uzávěry
############################################################################
def genf(id):
        count = 0
        def g():
            nonlocal count
            count += 1
            return id + '_' + str(count)
        return g

ga = genf('A');   gb = genf('B')
ga(), ga(), gb(), ga(), gb()
# ('A_1', 'A_2', 'B_1', 'A_3', 'B_2')
# >>>



#Výpis 9.Y: Popisek
############################################################################
if DBG>0: print(f'===== Modul {__name__} ===== STOP')
