#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/64_PGM/64_PYT/m10__Rozhodování_a_cykly.py
"""
Kopie pasáží se záznamy komunikace se systémem realizovanými v IDLE
a uvedenými ve výpisech kapitoly:  10  Rozhodování a cykly.

Co se v kapitole naučíte
Tato kapitola probere příkazy, v nichž se rozhodujete o dalším postupu.
Nejprve představí podmíněný příkaz s jeho různými modifikacemi,
pak předvede možnosti rekurzivního volání, a poté se zaměří na cykly,
což jsou programové konstrukce řídící opakování provádění zadané části
programu. Představí vám různé druhy cyklů, u nichž o pokračování rozhoduje
splnění nějaké podmínky.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
from dbg import DBG
if DBG>0: print(f'===== Modul {__name__} ===== START')
############################################################################



#Výpis 10.1: Ukázka použití jednoduchého podmíněného příkazu
############################################################################
def ifThen(číslo):
    """Doplní číslo slovním vyjádřením znaménka."""
    znam = 'plus '      # Předpokládám, že číslo je kladné
    if číslo < 0:       # Oprava pro záporné číslo
        znam  = 'minus '
        číslo = -číslo
    print (znam, číslo);

ifThen(5); ifThen(-7)
# plus 5
# minus 7
# >>>



#Výpis 10.2: Ukázka použití úplného podmíněného příkazu
############################################################################
def ifElse(číslo):
    """Doplní číslo slovním vyjádřením znaménka."""
    if (číslo > 0):     # Verze pro kladná čísla
        text = "plus " + str(číslo)
    else:               # Verze pro záporná čísla
        text = "minus " + str(-číslo)
    print(text)

ifElse(5);ifElse(-7)
# plus 5
# minus 7
def ifExpr(číslo):
    """Tiskne hodnotu podmíněného výrazu."""
    print( ("plus "  + str( číslo))  if  (číslo > 0)
      else ("minus " + str(-číslo)) )

ifExpr(5); ifExpr(-7)
# plus 5
# minus 7
# >>>



#Výpis 10.3: Ukázky použití rozšířeného podmíněného příkazu
############################################################################
def akt_1(sezona):
    """Těla jsou na stejném řádku jako hlavička příkazu."""
    if   sezona == 'zima'  : akt = 'spí'
    elif sezona == 'jaro'  : akt = 'kvete'
    elif sezona == 'léto'  : akt = 'zraje'
    elif sezona == 'podzim': akt = 'plodí'
    else: return "Špatně zadaná sezóna: " + str(sezona)
    return 'Je-li ' + str(sezona) + ', jabloň ' + str(akt)

print(akt_1('jaro'));print(akt_1('podzim'));print(akt_1('nevim'))
# Je-li jaro, jabloň kvete
# Je-li podzim, jabloň plodí
# Špatně zadaná sezóna: nevim
def akt_2(sezona):
    """Těla nejsou na stejném řádku jako hlavička příkazu."""
    if   sezona == 'zima':
         akt = 'spí'
    elif sezona == 'jaro':
         akt = 'kvete'
    elif sezona == 'léto':
         akt = 'zraje'
    elif sezona == 'podzim':
         akt= 'plodí'
    else:
         return "Špatně zadaná sezóna: " + str(sezona)
    return 'Je-li ' + str(sezona) + ', jabloň ' + str(akt)

print(akt_2('jaro'));print(akt_2('podzim'));print(akt_2('nevím'))
# Je-li jaro, jabloň kvete
# Je-li podzim, jabloň plodí
# Špatně zadaná sezóna: nevím
# >>>



#Výpis 10.4: Definice modulu m10a_DBG_demo
############################################################################

""" Je uloženo v souboru m10a_DBG_demo.py. """



#Výpis 10.5: Chování kontrolních tisků
############################################################################
import m10a_DBG_demo as demo
# ===== Modul dbg ===== START
# ===== Modul dbg ===== STOP
# ===== Modul m10a_DBG_demo ===== START
# ===== Modul m10a_DBG_demo ===== STOP
demo.dbg_fce()
# === Funkce demo_dbg === START
#     Provádí se tělo funkce: DBG = 1  x  dbg.DBG = 1
# === Funkce demo_dbg === RETURN
import dbg;   dbg.DBG = 0
demo.dbg_fce()
# === Funkce demo_dbg === START
#     Provádí se tělo funkce: DBG = 1  x  dbg.DBG = 0
# === Funkce demo_dbg === RETURN
demo.DBG = 0
demo.dbg_fce()
#     Provádí se tělo funkce: DBG = 0  x  dbg.DBG = 0
# >>>



#Výpis 10.6: Ukázky definic funkcí používajících rekurzivní volání
############################################################################
def recDemo(n, s=''):
    """Demonstrace rekurzivního volání."""
    print(s, '==>', n)               # Funkce ohlašuje svůj start
    if n>0 : recDemo(n-1, s+'  ')    # Hlášení bude posunuté o dvě mezery
    print(s, n , '<==')              # Funkce ohlašuje svoje ukončení

recDemo(5)
#  ==> 5
#    ==> 4
#      ==> 3
#        ==> 2
#          ==> 1
#            ==> 0
#            0 <==
#          1 <==
#        2 <==
#      3 <==
#    4 <==
#  5 <==
def r():    # Demonstrace neukončeného rekurzivního volání
    r()     # Neexistence ukončovací podmínky vede k nekonečné rekurzi

r()   # Nekonečná rekurze vede k přetečení zásobníku
# Traceback (most recent call last):
#   File "<pyshell#179>", line 1, in <module>
#     r()
#   File "<pyshell#178>", line 2, in r
#     r()
#   File "<pyshell#178>", line 2, in r
#     r()
#   File "<pyshell#178>", line 2, in r
#     r()
#   [Previous line repeated 991 more times]
# RecursionError: maximum recursion depth exceeded
def factR(n):
    """Rekurzivní definice faktoriálu."""
    if n<=1 : return 1
    return n * factR(n-1)

factR(5)
#120
factR(99)    # Python umožňuje spočítat i faktoriál velkých čísel
#933262154439441526816992388562667004907159682643816214685929638952175999932299156089414639761565182862536979208272237582511852109168640000000000000000000000
#>>>



#Výpis 10.7: Ukázky definic funkcí používajících cyklus while
############################################################################
def countDown(n):
    """Vytiskne zadaný počet znaků – a po nich slovo BUM"""
    while n>0:
        print(n, end='-')
        n -= 1
    print('BUM')

countDown(5)
# 5-4-3-2-1-BUM
def factW(n):
    """Faktoriál počítaný pomocí cyklu while."""
    f = 1      # Hodnota vracená v případě, když n <= 1
    while n > 1:
        f *= n
        n -= 1
    return f

factW(5)
# 120
# >>>



#Výpis 10.8: Nekonečný cyklus
############################################################################
def infinite():
        """Spustí prázdný nekonečný cyklus, který bude nutné přerušit zvenku."""
        while True: pass
        print('Hotovo')

infinite ()
# Traceback (most recent call last):
#   File "<pyshell#2>", line 1, in <module>
#     infinite()
#   File "<pyshell#1>", line 2, in infinite
#     while True: pass
# KeyboardInterrupt
# >>>



#Výpis 10.9: Použití příkazu break
############################################################################
def cumul(time: int,       # Kolik období se bude úročit
          interest: float, # Velikost úroku
         ) -> float:       # Akumulovaný násobek základní částky
    """Spočte násobek zadané částky pro zadaný počet úrokových období."""
    multiplier = 1 + interest/100
    sum = 1.    # Základní částka
    n   = 1     # Pořadové číslo období
    print("Průběžné násobky základní částky: 1,000", end='')
    while True:
        sum *= multiplier
        if n >= time : break    #---------->
        print(' - ', n, ':', round(sum,3), sep='', end='')
        n += 1
    print('\nPo ', time, ' obdobích se při úroku ', interest, ' % naspoří ',
          round(sum,3), '-násobek základní částky.', sep='')

cumul(5,5)
# Průběžné násobky základní částky: 1,000 - 1:1.05 - 2:1.103 - 3:1.158 - 4:1.216
# Po 5 obdobích se při úroku 5 % naspoří 1.276-násobek základní částky.
# >>>



#Výpis 10.10: Použití přiřazovacího výrazu v hlavičce cyklu while
############################################################################
seznam = 'Účastníci: '
while ((osoba:=input('Jméno: ')) != ''):
    seznam += osoba + ', '
    print(seznam)

# Jméno: Franta
# Účastníci: Franta,
# Jméno: Pepa
# Účastníci: Franta, Pepa,
# Jméno: Alena
# Účastníci: Franta, Pepa, Alena,
# Jméno:
while (True):
        osoba = input('Jméno: ')
        if (osoba == ''): break
        seznam += osoba + ', '
        print(seznam)

# Jméno: Kazimír
# Účastníci: Franta, Pepa, Alena, Kazimír,
# Jméno:
# >>>



#Výpis 10.11: Cyklus while využívající větev else
############################################################################
def isPrime(n: int):
    """Vypíše, zda je zadaný argument prvočíslem."""
    d = n // 2          # Dělitel může být nejvýše poloviční
    while d > 1:
        if n % d == 0:  # Zbytek po dělení
            print(n, 'je dělitelné číslem', d, end=' # ')
            break       # Větev else se přeskakuje
        d -= 1
    else: # Standardní konec:
        print(n, 'je prvočíslo', end=' ! ')
    print('KONEC TESTU')

isPrime(35); isPrime(37)
# 35 je dělitelné číslem 7 # KONEC TESTU
# 37 je prvočíslo ! KONEC TESTU
# >>>



#Výpis 10.12: Použití příkazu continue
############################################################################
def sum3xC(x,   # Číslo, jehož následníci se mají sčítat
           n):  # Počet sčítaných následníků nedělitelných třemi
    """Sečte zadaný počet čísel nedělitelných třemi následujících
       za zadaným číslem."""
    s = 0
    while n > 0:
        x += 1
        if x % 3 == 0:
            print(x, "ne", sep='', end=' ')
            continue
        s += x
        print("+", x, end=' ')
        n -= 1
    print("=", s)

sum3xC(7, 7)
# + 8 9ne + 10 + 11 12ne + 13 + 14 15ne + 16 + 17 = 89
def sum3xE(x,    # Číslo, jehož následníci se mají sčítat
           n):   # Počet sčítaných následníků nedělitelných třemi
    """Sečte zadaný počet čísel nedělitelných třemi následujících
       za zadaným číslem."""
    s = 0
    while n > 0:
        x += 1
        if x % 3 == 0:
            print(x, "ne", sep='', end=' ')
        else:
          s += x
          print("+", x, end=' ')
          n -= 1
    print("=", s)

sum3xE(5, 5)
# 6ne + 7 + 8 9ne + 10 + 11 12ne + 13 = 49
# >>>



#Výpis 10.Y: Popisek
############################################################################
if DBG>0: print(f'===== Modul {__name__} ===== STOP')
