#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/64_PGM/64_PYT/m11__Cyklus_for.py
"""
Kopie pasáží se záznamy komunikace se systémem realizovanými v IDLE
a uvedenými ve výpisech kapitoly:  10  Rozhodování a cykly.

Co se v kapitole naučíte
TTato kapitola se zaměří na výklad cyklu for používaného při postupném
zpracovávání dat dodávaných nějakým zdrojem.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
from dbg import DBG
if DBG>0: print(f'===== Modul {__name__} ===== START')
############################################################################



#Výpis 11.1: Použití příkazu for se zdrojem definovaným jako sada hodnot
############################################################################
for val in (i:=1), 2+3j, 'čtyři', print, '5**3='+str(5**3):
    print(i, '. položka = ', repr(val), sep='')
    i += 1

# 1. položka = 1
# 2. položka = (2+3j)
# 3. položka = 'čtyři'
# 4. položka = <built-in function print>
# 5. položka = '5**3=125'
# >>>



#Výpis 11.2: Použití příkazu for se zdrojem generovaným funkcí range()
############################################################################
for x in range(3*(step:=12), 99, step):
    print(x, "-", x*x, sep='', end=', ')

# 36-1296, 48-2304, 60-3600, 72-5184, 84-7056, 96-9216,
step = 12
for x in range(3*step, 99, step):
    print(x, "-", x*x, sep='', end=', ')

# 36-1296, 48-2304, 60-3600, 72-5184, 84-7056, 96-9216,
# >>>



#Výpis 11.3: Indexace znaků v textovém řetězci – stringu
############################################################################
def indexing(s):
    n = len(s)
    print('Text: "' + s + '", znaků=' + str(n))
    for i in range(n):
        print(' ' + str(i) + ":" + s[i] + '  ', end='')
    print()
    for i in range(-1, -n-1, -1):
        print(i, ':', s[i], '  ', sep='', end='')

indexing('Python')
# Text: "Python", znaků=6
#  0:P   1:y   2:t   3:h   4:o   5:n
# -1:n  -2:o  -3:h  -4:t  -5:y  -6:P
# >>>



#Výpis 11.4: Zpracování jednotlivých znaků v textovém řetězci bez použití indexů
############################################################################
for c in "Dobrý den":
    print('(', c, ') ', sep='', end='')

# (D) (o) (b) (r) (ý) ( ) (d) (e) (n)
# >>>



#Výpis 11.5: Ukázka zanořování cyklů
############################################################################
def seq_in_radix(radix):
    """Vypíše posloupnost 3ciferných hodnot v zadané číselné soustavě."""
    for c2 in range(radix):
        for c1 in range(radix):
            for c0 in range(radix):
                s = str(c2) + str(c1) + str(c0)
                print(s, end=', ')

seq_in_radix(2)
# 000, 001, 010, 011, 100, 101, 110, 111,
seq_in_radix(3)
# 000, 001, 002, 010, 011, 012, 020, 021, 022, 100, 101, 102, 110, 111, 112, 120, 121, 122, 200, 201, 202, 210, 211, 212, 220, 221, 222,
# >>>



#Výpis 11.6: Příkaz for s postupným použitím více zdrojů
############################################################################
for x in range(1, 5), range(11, 15): print(x, end=', ')

# range(1, 5), range(11, 15)
for x in range(1, 5),: print(x, end=', ')

# range(1, 5),
for source in range(1, 5), range(11, 15):
    for x in source: print(x, end=', ')

# 1, 2, 3, 4, 11, 12, 13, 14,
# >>>



#Výpis 11.7: Definice a použití generátorové funkce gen1() demonstrující některé
#             možnosti použití výrazu yield
############################################################################
# >>> \
def gen1(number):
    """Funkce demonstruje některé možnosti použití výrazu yield."""
    yield('Start: ' + str(number))
    for s in ('První', 'Druhý', 'Třetí'):
        yield ('\n' + s + ': ')
        for n in range(number, number+3):
            yield n
        number = n
    yield '\nKONEC\n'

for x in gen1(17): print(x, end='')

# Start: 17
# První: 171819
# Druhý: 192021
# Třetí: 212223
# KONEC
# >>>



#Výpis 11.8: Příkaz for s větví else
############################################################################
def for_else(start, step):
    """Vypíše prvních pět členů aritmetické řady se zadaným startem
    a krokem; objeví-li se však třináctka, výpis ukončí.
    """
    for n in range(start, start+5*step, step):
        if n == 13: break
        print(n, end='-')
    else:
        print('Povedlo se')
        return
    print('Zakopli jsme o třináctku')

for_else(0, 5)
# 0-5-10-15-20-Povedlo se
for_else(9, 2)
# 9-11-Zakopli jsme o třináctku
# >>>



#Výpis 11.9: Zobrazení cyklu for s větví else v okně konzole
############################################################################
for n in range(0, 5):
    if n == 13: print('Zakopli jsme o třináctku'); break
    print(n, end='-')
else:
    print('Povedlo se')

# 0-1-2-3-4-Povedlo se
# >>>



#Výpis 11.10: Zobrazení cyklu for s větví else v příkazovém okně IDLE
#
# Zdrojový kód neodpovídá, zadání je v r10_00_Rozhodování_a_cykly.pyrec
############################################################################
for n in range(0, 5):
    if n == 13: print('Zakopli jsme o třináctku'); break
    print(n, end='-')
else:
    print('Povedlo se')

# SyntaxError: unindent does not match any outer indentation level
for n in range(0, 5):
    if n == 13: print('Zakopli jsme o třináctku'); break
    print(n, end='-')
else:
    print('Povedlo se')

# 0-1-2-3-4-Povedlo se
# >>> \
for n in range(0, 5):
    if n == 13: print('Zakopli jsme o třináctku'); break
    print(n, end='-')
else:
    print('Povedlo se')

# 0-1-2-3-4-Povedlo se
# >>>



#Výpis 11.Y: Popisek
############################################################################
if DBG>0: print(f'===== Modul {__name__} ===== STOP')
