# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ ó
#P:/64_PGM/64_PYT/m13a_Pascal.py
"""
Metoda vytvářející Pascalův trojúhelník a metoda, která jej tiskne.
"""

# print( '===== START načítání modulu', __name__, '=====')


def pascal(deep):
    """Vytvoří Pascalův trojúhelník zadané hloubky jako seznam seznamů."""
    if deep <= 0:
        raise Exception("Trojúhelník musí mít kladný počet řádků")
    pas = [[1]]     # První řádek trojúhelníku
    if deep == 1: return pas
    pas.append([1,1])     # Druhý řádek trojúhelníku
    # Každý prvek kromě prvního a posledního, kterými jsou jedničky,
    # je součtem dvou prvků nad ním
    for r in range(2, deep):
        row =[1]    # První prvek v řádku
        for c in range(1, r):
            row.append(pas[r-1][c-1] + pas[r-1][c])
        row.append(1)       # Poslední prvek v řádku
        pas.append(row)     # Vytvořený řádek se přidá jako další
    return pas  # Vrací vytvořený Pascalův trojúhelník

def printpas(pas):
    """Vráti string zobrazující zadaný Pascalův trojúhelník
       jako rovnoramenný trojúhelník.
    """
    deep = len(pas)     # Počet řádků trojúhelníku
    s    = ""           # String pro vytvářený trojúhelník
    for r in range(deep):   # Převádíme řádek za řádkem
        s += (deep-r)*' '   # Odsazení řádku se postupně zmenšuje
        for c in range(len(pas[r])):    # Přidáme jednotlivé položky
            s += str(pas[r][c]) + ' '   # oddělené jednou mezerou
        s += '\n'   # A řádek ukončíme
    return s


# print('===== KONEC načítání modulu''', __name__, '=====')
