#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/64_PGM/64_PYT/m14__Ntice.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
14  N-tice.

Co se v kapitole naučíte
Tato kapitola vás seznámí s n-ticemi, které bychom mohli chápat jako
neměnné seznamy. Nejprve vysvětlí, jak je možné n-tici vytvořit,
poté probere generátorovou notaci, možnosti přístupu k jednotlivým prvkům
a hlouběji rozebere problematiku neměnnosti.
Na závěr pak představí možnosti sčítání seznamů a n tic.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
from dbg import DBG
if DBG>0: print(f'===== Modul {__name__} ===== START')
############################################################################



#Výpis 14.1: Vytváření n-tic pomocí literálů
############################################################################
x, y, z = 10, 20, 30
x, y, z
# (10, 20, 30)
t3 = 11, 22, 33;    t3
# (11, 22, 33)
(t3 := 11, 22, 33);   t3   # Význam: ((t3 := 11), 22, 33)
# (11, 22, 33)
# 11
(t3 := (11, 22, 33))
# (11, 22, 33)
t0 = ()
t1 =  101, ;   t1
# (101,)
t1 = (111,);   t1
# (111,)
t2 = ('Raz', 'Dva',)
(t4 := (t0, t1, t2, t3))
# ((), (111,), ('Raz', 'Dva'), (11, 22, 33))
# >>>



#Výpis 14.2: Vytváření n-tic pomocí funkce tuple()
############################################################################
tuple('Python')
# ('P', 'y', 't', 'h', 'o', 'n')
tuple(range(5))
# (0, 1, 2, 3, 4)
tuple([10,20,30])
# (10, 20, 30)
from utils import gen_fibonacci
tuple(gen_fibonacci(7))
# ((1, 1), (2, 2), (3, 3), (4, 5), (5, 8), (6, 13), (7, 21))
tuple()
# ()
# >>>



#Výpis 14.3: Vytváření n-tic z jiných n tic pomocí sčítání a násobení
############################################################################
t4;  t0 + t1 + t2 + t3 + (('a', 2), list('nic'))
# ((), (111,), ('Raz', 'Dva'), (11, 22, 33))
# (111, 'Raz', 'Dva', 11, 22, 33)
t23 = t2 * 3;   t23
# ('Raz', 'Dva', 'Raz', 'Dva', 'Raz', 'Dva')
t1 + [222, 333]
# Traceback (most recent call last):
#   File "<pyshell#34>", line 1, in <module>
#     t1 + [222, 333]
# TypeError: can only concatenate tuple (not "list") to tuple
t1 + tuple([222, 333])
# (111, 222, 333)
# >>>



#Výpis 14.4: Vytváření n-tic přičítáním
############################################################################
tpl = (1, 2);   (tpl1 := tpl)
# (1, 2)
tpl += (3, 4);      tpl1;   tpl
# (1, 2)
# (1, 2, 3, 4)
# >>>



#Výpis 14.5: Balení a rozbalování n-tic a seznamů
############################################################################
(raz, dva, tři) = (1, 2, 3)
print('raz=', raz, ', dva=', dva, ', tři=', tři, sep='')
# raz=1, dva=2, tři=3
one, two, three = 11, 22, 33
print('one = ', one, ', two = ', two, ', three = ', three, sep='')
# one = 11, two = 22, three = 33
[a, b] = [11, 22]
[c, d] = 33, 43
[e, f] = (55, 66)
(g, h) = 77, 88
i, j = [99, 111]
k, l = (222, 333)
a, b, c, d, e, f, g, h, i, j, k, l
# (11, 22, 33, 43, 55, 66, 77, 88, 99, 111, 222, 333)
# >>>



#Výpis 14.6: Prohazování hodnot proměnných
############################################################################
t0, t1, t2
# ((), (111,), ('Raz', 'Dva'))
tpom = t0;   t0 = t1;   t1 = t2;   t2 = tpom
print('t0=', t0, ', t1=', t1, ', t2=', t2, sep='')
# t0=(111,), t1=('Raz', 'Dva'), t2=()
t0, t1, t2 = t2, t0, t1
print('t0=', t0, ', t1=', t1, ', t2=', t2, sep='')
# t0=(), t1=(111,), t2=('Raz', 'Dva')
# >>>



#Výpis 14.7: Hvězdičkové pravidlo
############################################################################
x = (1, 2, 3, 4)
a, b, *c = x;   a, b, c
# (1, 2, [3, 4])
a, *b, c = x;   a, b, c
# (1, [2, 3], 4)
*a, b, c = x;   a, b, c
# ([1, 2], 3, 4)
a, b, c, d, *e = x;   a, b, c, d, e
# (1, 2, 3, 4, [])
# >>>



#Výpis 14.8: Vytvoření n tice pomocí generátoru
############################################################################
gen = (x*x for x in range(3, 30, 3));   gen
# <generator object <genexpr> at 0x0000028AE118B890>
tuple(gen)
# (9, 36, 81, 144, 225, 324, 441, 576, 729)
tuple(x for x in range(3, 30, 3) if x&1 != 0)
# (3, 9, 15, 21, 27)
tuple((a,n) for a in 'abc' for n in (0,1))
# (('a', 0), ('a', 1), ('b', 0), ('b', 1), ('c', 0), ('c', 1))
# >>>



#Výpis 14.9: Přístup k prvkům n tic
############################################################################
tpl = ([1,2,3], [10,20,30])
tpl[1][1] = 22;   tpl
# ([1, 2, 3], [10, 22, 30])
# >>>



#Výpis 14.10 Chování n tic s proměnnými a neměnnými prvky
############################################################################
tpl = a, b, c = ('aa',), ('bb',), ('cc',);   tpl, c; \
c  += ('CC',);                               tpl, c
# ((('aa',), ('bb',), ('cc',)), ('cc',))
# ((('aa',), ('bb',), ('cc',)), ('cc', 'CC'))
tpl = a, b, c = ['aa',], ['bb',], ['cc',];   tpl, c; \
c  += ['CC'];                                tpl, c
# ((['aa'], ['bb'], ['cc']), ['cc'])
# ((['aa'], ['bb'], ['cc', 'CC']), ['cc', 'CC'])
# >>>



#Výpis 14.Y: Popisek
############################################################################
if DBG>0: print(f'===== Modul {__name__} ===== STOP')
