#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/64_PGM/64_PYT/m22__Třídy_a_jejich_instance.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
22  Třídy a jejich instance.

Co se v kapitole naučíte
Tato kapitola vás nejprve naučí definovat třídu a její atributy.
Ukáže vám, jak je možné atributy dodatečně přidávat, odebírat a měnit.
Poté vám vysvětlí, jak zařídit, aby třída správně vytvářela své instance,
jak ve třídě definovat vlastnosti a schopnosti jejích instancí
a jak s vytvořenými instancemi následně pracovat. Na závěr představí
některé speciální atributy a probere zvláštnosti zabudovaných tříd.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
from dbg import DBG
if DBG>0: print(f'===== Modul {__name__} ===== START')
############################################################################



#Výpis 22.1: Definice třídy a jejích atributů
# Pro zanesení do knihy odebrat "@staticmethod" před C1.cm a C1.C11.cm
############################################################################
class C0: """Třída s prázdným tělem""";   pass

# >>> \
class C1:
    """Třída definující svůj datový, funkční i typový atribut,
       tj. datovou proměnnou, metodu a třídu.
       Současně demonstruje spouštění příkazů v těle při definici.
    """
    print('START definice třídy C1')

    ca = 'Atribut ca třídy C1'

    @staticmethod   # Před zařazením do knihy odebrat
    def cm():
        """Statická metoda třídy C1 -- volá se "C1.cm()"."""
        print('Byla zavolána metoda C1.cm')

    class C11:
        """Vnitřní třída třídy C1 - oslovuje se "C1.C11".
           Má vlastní datový atribut a funkční atribut (metodu).
        """
        print('START definice třídy C1.C11')
        ca = 'Atribut ca třídy C1.C11'

        @staticmethod   # Před zařazením do knihy odebrat
        def cm():
            """Statická metoda třídy C11 - volá se "C1.C11.cm()"."""
            print('Byla zavolána metoda C1.C11.cm')

        print('KONEC definice třídy C1.C11')

    print('KONEC definice třídy C1')

# START definice třídy C1
# START definice třídy C1.C11
# KONEC definice třídy C1.C11
# KONEC definice třídy C1
type(C0), type(C1), type(C1.C11)
# (<class 'type'>, <class 'type'>, <class 'type'>)
# >>>



#Výpis 22.2: Práce s atributy objektu
############################################################################
C1.ca,   C1.C11.ca;   C1.cm();   C1.C11.cm()
# ('Atribut ca třídy C1', 'Atribut ca třídy C1.C11')
# Byla zavolána metoda C1.cm
# Byla zavolána metoda C1.C11.cm
C1.ca = 'Upravený atribut třídy C1'
f"{C1.ca =}"
# "C1.ca ='Upravený atribut třídy C1'"
# >>>



#Výpis 22.3: Přidávání a odstraňování atributů objektu
############################################################################
#!# f"{C0.ca =}"
# Traceback (most recent call last):
#   File "<pyshell#20>", line 1, in <module>
#     f"{C0.ca =}"
# AttributeError: type object 'C0' has no attribute 'ca'
C0.ca = 'Atribut třídy C0'
f"{C0.ca =}"
# "C0.ca ='Atribut třídy C0'"
C0.cm = lambda: print('Byla zavolána metoda C0.cm')
C0.cm()
# Byla zavolána metoda C0.cm
del C0.ca
#!# f"{C0.ca =}"
# Traceback (most recent call last):
#   File "<pyshell#27>", line 1, in <module>
#     f"{C0.ca =}"
# AttributeError: type object 'C0' has no attribute 'ca'
# >>>



#Výpis 22.4: Třída jako parametr funkce
############################################################################
def method(cls):
    print('Třída', cls.__name__, '- ', end='')
    cls.cm()

method(C0);   method(C1);   method(C1.C11);
# Třída C0 - Byla zavolána metoda C0.cm
# Třída C1 - Byla zavolána metoda C1.cm
# Třída C11 - Byla zavolána metoda C1.C11.cm
# >>>



#Výpis 22.5: Vytvoření prvních instancí
############################################################################
c1a = C1()   # Vytvářím instanci třídy C1
type(c1a);   c1a;   C0()
# <class '__main__.C1'>
# <__main__.C1 object at 0x000001CFC8E90160>
# <__main__.C0 object at 0x000001CFC8E90550>
c1a.ca
# 'Upravený atribut třídy C1'
c1a.cm()
# Traceback (most recent call last):
#   File "<pyshell#32>", line 1, in <module>
#     c1a.cm()
# TypeError: cm() takes 0 positional arguments but 1 was given
C1.cm = staticmethod(C1.cm)
c1a.cm()
# Byla zavolána metoda C1.cm
# >>>



#Výpis 22.6: Přidání a použití instanční metody
############################################################################
def im(self): """Budoucí instanční metoda.""";   print(self.ia)

C1.im = im     # Odkaz na metodu přidám mezi třídní atributy
del im         # a proměnnou s odkazem na definici metody smažu
c1a.ia = 'Instanční atribut ia' # Připravím atribut tisknutý metodou
c1a.im();   C1.im(c1a)          # a metodu zavolám
# Instanční atribut ia
# Instanční atribut ia
# >>>



#Výpis 22.7: Definice třídy C2
############################################################################
# >>> \
class C2:
    """Třída definující initor a podpisové metody."""

    ca = 'Atribut třídy C2'
    count = 0     # Inicializace počtu vytvořených instancí

    def __init__(self):
        """Initor instancí třídy C2."""
        C2.count += 1       # Vytvářím další instanci
        self.ID = C2.count  # Identifikační (rodné) číslo instance
        self.ia = f"Atribut {self.ID}. instance třídy C2"
        print('Vytvořena ', self.ID, '. instance třídy C2', sep='')

    def im(self, x):
        """Instanční metoda s jedním parametrem."""
        print('Metoda instance', self, 's parametrem x =', repr(x))

    def __repr__(this):
        """Převod instance na text používaný systémem."""
        return ('<C2_' + str(this.ID) + '>')

    def __str__(moje):
        """Převod instance na text používaný funkcí print."""
        return ('«C2_' + str(moje.ID) + '»')

# >>>



#Výpis 22.8: Vytváření instancí třídy C2 a používání jejich atributů
############################################################################
c2a=C2();   c2b=C2();   c2c=C2()
# Vytvořena 1. instance třídy C2
# Vytvořena 2. instance třídy C2
# Vytvořena 3. instance třídy C2
c2a,  c2b,  c2c
# (<C2_1>, <C2_2>, <C2_3>)
print(c2a,  c2b,  c2c, sep=', ')
# «C2_1», «C2_2», «C2_3»
print(c2c.ca, c2c.ia, sep=' - ')
# Atribut třídy C2 - Atribut 3. instance třídy C2
c2b.im('přes instanci')
# Metoda instance «C2_2» s parametrem x = 'přes instanci'
C2.im(c2c, 'přes třídu')
# Metoda instance «C2_3» s parametrem x = 'přes třídu'
C2.im(C2(), 'čerstvě vytvořená')
# Vytvořena 4. instance třídy C2
# Metoda instance «C2_4» s parametrem x = 'čerstvě vytvořená'
# >>>



#Výpis 22.9: Vytváření nových instančních datových atributů
############################################################################
c2a.ia2 = f"Druhý atribut instance {c2a}"
c2a.ia2
# 'Druhý atribut instance «C2_1»'
#!# c2b.ia2
# Traceback (most recent call last):
#   File "<pyshell#125>", line 1, in <module>
#     c2b.ia2
# AttributeError: 'C2' object has no attribute 'ia2'
# >>>


#Výpis 22.10: Změny třídních datových atributů
############################################################################
C2.ca,   c2a.ca,   c2b.ca
# ('Atribut třídy C2', 'Atribut třídy C2', 'Atribut třídy C2')
C2.ca = 'Attr_C2.ca'
C2.ca,   c2a.ca,   c2b.ca
# ('Attr_C2.ca', 'Attr_C2.ca', 'Attr_C2.ca')
C2.ca2 = 'Attr_C2.ca2'
C2.ca2, c2a.ca2, c2b.ca2
# ('Attr_C2.ca2', 'Attr_C2.ca2', 'Attr_C2.ca2')
c2a.ca = 'Změna'
C2.ca,   c2a.ca,   c2b.ca
# ('Attr_C2.ca', 'Změna', 'Attr_C2.ca')
# >>>



#Výpis 22.11: Třídní datový atribut jako implicitní hodnota instančního
############################################################################
# >>> \
class C3:
    """Experimentální třída pro demonstraci lokality atributů."""

    ca = 'Třídní'   # Implicitní hodnota stejnojmenných instančních atr.

    def __init__(self, ca = None):
        """Atribut se vytváří pouze tehdy, je-li zadán argument ca."""
        if (ca):  self.ca = ca

    def get_ca(self):
        """Vrací aktuálně platnou hodnotu ca - instanční či třídní."""
        return self.ca

    def __repr__(self):
        """Textový podpis instance používaný systémem."""
        return f'<C3: {self.ca=}>'

(c30 := C3()).ca, (c31 := C3('Instanční')).ca
# ('Třídní', 'Instanční')
c30, c31;   print((c30, c31))
# (<C3: self.ca='Třídní'>, <C3: self.ca='Instanční'>)
# (<C3: self.ca='Třídní'>, <C3: self.ca='Instanční'>)
# >>>



#Výpis 22.12: Zavádění nových třídních funkčních atributů
############################################################################
# >>> \
def im2(self, text):
    """Funkce určená k přidání do C2 jako nová metoda."""
    print('Druhá metoda instance', self, 's parametrem text =', repr(text))

C2.im2 = im2;   del im2   # Proměnnou s odkazem na funkci smaže
c2a.im2('první'); C2().im2('pátá'); C2.im2(c2c, 'třetí')
# Druhá metoda instance «C2_1» s parametrem text = 'první'
# Vytvořena 5. instance třídy C2
# Druhá metoda instance «C2_5» s parametrem text = 'pátá'
# Druhá metoda instance «C2_3» s parametrem text = 'třetí'
# >>>



#Výpis 22.13: Zavádění nových instančních funkčních atributů
############################################################################
c2a.im3 = lambda self, arg: f'Metoda im3, {self=}, {arg=}'
#!# c2a.im3('Neprojde')
# Traceback (most recent call last):
#   File "<pyshell#161>", line 1, in <module>
#     c2a.im3('Neprojde')
# TypeError: <lambda>() missing 1 required positional argument: 'arg'
c2a.im3(c2b, 'Projde')
# "Metoda im3, self=<C2_2>, arg='Projde'"
C2.im3 = c2a.im3;   del c2a.im3
c2a.im3('Už projde')
# "Metoda im3, self=<C2_1>, arg='Už projde'"
# >>>



#Výpis 22.14: Demonstrace nutnosti kvalifikace atributů
############################################################################
# >>> \
class C4:
    """Experimentální třída pro demonstraci lokality názvů"""

    atr = "Třídní"

    def mtd0():   return atr;
    def mtd1():   atr    = 'Lokální';   return atr
    def mtd2():   C4.atr = 'Změněný';   return C4.atr
    staticmethod(mtd0);   staticmethod(mtd1);   staticmethod(mtd2)

C4.atr,   C4.mtd1(),   C4.atr
# ('Třídní', 'Lokální', 'Třídní')
C4.atr,   C4.mtd2(),   C4.atr
# ('Třídní', 'Změněný', 'Změněný')
#!# C4.mtd0()
# Traceback (most recent call last):
#   File "<pyshell#195>", line 1, in <module>
#     C4.mtd0()
#   File "<pyshell#192>", line 7, in mtd0
#     def mtd0():   return atr;
# NameError: name 'atr' is not defined
# >>>



#Výpis 22.15: Ukázky použití systémových atributů
############################################################################
# >>> \
def prdict(d):
    """Vytiskne položky zadaného slovníku, každou na samostatný řádek."""
    for k, v in d.items(): print(k, '=', v)

prdict(C2.__dict__)
# __module__ = __main__
# __doc__ = Třída definující initor a podpisové metody.
# ca = Atribut třídy C2
# count = 5
# __init__ = <function C2.__init__ at 0x0000029E4AF9FAF0>
# im = <function C2.im at 0x0000029E4AF9FB80>
# __repr__ = <function C2.__repr__ at 0x0000029E4AF9F940>
# __str__ = <function C2.__str__ at 0x0000029E4AF9F5E0>
# __dict__ = <attribute '__dict__' of 'C2' objects>
# __weakref__ = <attribute '__weakref__' of 'C2' objects>
# ca2 = Attr_C2.ca2
prdict(c2a.__dict__)
# ID = 1
# ia = Atribut 1. instance třídy C2
# ia2 = Druhý atribut instance «C2_1»
# ca = Změna
prdict(c2b.__dict__)
# ID = 2
# ia = Atribut 2. instance třídy C2
c2a.__class__,   c2a.__class__.__name__
# (<class '__main__.C2'>, 'C2')
# >>>



#Výpis 22.Y: Popisek
############################################################################
if DBG>0: print(f'===== Modul {__name__} ===== STOP')
