#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/64_PGM/64_PYT/m23__Dědění.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
23  Jednoduché dědění.

Co se v kapitole naučíte
Teoretické základy dědění jsme probrali v podkapitole 20.8  Dědění
na straně 344. Tato kapitola vás naučí jednoduché dědění v Pythonu zadávat
a vysvětlí vám, jaká pravidla se při jeho používání uplatňují.
Na závěr vám představí zabudované funkce pracující s objekty.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
from dbg import DBG
if DBG>0: print(f'===== Modul {__name__} ===== START')
############################################################################



#Výpis 23.1: Definice tříd LA, LB a LC v modulu m23a_LABC
############################################################################

# Definice se nacházejí v modulu m23a_LABC



#Výpis 23.2: Jmenné prostory tříd z modulu m23a_LABC a jejich instancí
############################################################################
from m23a_LABC import *
a1 = LA(1);   b1 = LB(1);   c1 = LC(1);   a1, b1, c1
# (LA_1, LB_1, LC_1)
a1.__dict__;   b1.__dict__;   c1.__dict__
# {'ID': 1, 'iX': 'LA_isp', 'iA': 'LA_ins'}
# {'ID': 1, 'iX': 'LB_isp', 'iA': 'LA_ins', 'iB': 'LB_ins'}
# {'ID': 1, 'iX': 'LC_isp', 'iA': 'LA_ins', 'iB': 'LB_ins', 'iC': 'LC_ins'}
from utils import prdict
prdict(LA);   prdict(LB);   prdict(LC)
# ##### Atributy objektu: <class 'm23a_LABC.LA'>
# cX = LA_csp
# cA = LA_cls
# mtdA = <function LA.mtdA at 0x00000278E126E280>
# mtdv = <function LA.mtdv at 0x00000278E126E310>
# ##### Atributy objektu: <class 'm23a_LABC.LB'>
# cX = LB_csp
# cB = LB_cls
# mtdB = <function LB.mtdB at 0x00000278E126E430>
# mtdv = <function LB.mtdv at 0x00000278E126E4C0>
# ##### Atributy objektu: <class 'm23a_LABC.LC'>
# cX = LC_csp
# cC = LC_cls
# mtdC = <function LC.mtdC at 0x00000278E126E5E0>
# mtdv = <function LC.mtdv at 0x00000278E126E670>
# >>>



#Výpis 23.3: Používání třídních atributů v hierarchii dědění
############################################################################
LC.cA,   LC.cB,   LC.cC,   LC.cX,   LB.cX,   LA.cX
# ('LA_cls', 'LB_cls', 'LC_cls', 'LC_csp', 'LB_csp', 'LA_csp')
c1.cA,   c1.cB,   c1.cC,   c1.cX
# ('LA_cls', 'LB_cls', 'LC_cls', 'LC_csp')
# >>>



#Výpis 23.4: Volání metod v hierarchii dědění
############################################################################
a1.mtdA(),; \
b1.mtdA(),   b1.mtdB(); \
c1.mtdA(),   c1.mtdB(),   c1.mtdC()
# ('LA_inst(LA_1)',)
# ('LA_inst(LB_1)', 'LB_inst(LB_1)')
# ('LA_inst(LC_1)', 'LB_inst(LC_1)', 'LC_inst(LC_1)')
a1.mtdv(),; \
b1.mtdv(), LA.mtdv(b1); \
c1.mtdv(), LA.mtdv(c1), LB.mtdv(c1)
# ('LA_virt(LA_1)',)
# ('LB_virt(LB_1)', 'LA_virt(LB_1)')
# ('LC_virt(LC_1)', 'LA_virt(LC_1)', 'LB_virt(LC_1)')
# >>>



#Výpis 23.5: Demonstrace dědění initorů
############################################################################
# >>> \
class Matka23:
    def __init__(self, a, b, c): self.t = (a, b, c)
    def __repr__(self): return f"{self.__class__.__name__}{self.t}"

class Dcera23(Matka23): pass

Matka23(1, 2, 3),   Dcera23(10, 20, 30)
# (Matka23(1, 2, 3), Dcera23(10, 20, 30))
Dcera23()
# Traceback (most recent call last):
#   File "<pyshell#29>", line 1, in <module>
#     Dcera23()
# TypeError: __init__() missing 3 required positional arguments: 'a', 'b', and 'c'
# >>>



#Výpis 23.6: Ukázka definice a použití vlastní výjimky
############################################################################
# >>> \
class RobotError(Exception):
    """Výjimka vyhazovaná při uvedení robota do chybového stavu.

    Atributy:
        robot -- Robot, který se dostal do chybového stavu
        message -- Popis chybového stavu
    """

    def __init__(self, robot, message):
        self.robot   = robot
        self.message = message

raise RobotError('Karel_1', 'Robot narazil do zdi')
# Traceback (most recent call last):
#   File "<pyshell#25>", line 1, in <module>
#     raise RobotError('Karel_1', 'Robot narazil do zdi')
# RobotError: ('Karel_1', 'Robot narazil do zdi')
# >>>



#Výpis 23.Y: Popisek
############################################################################
if DBG>0: print(f'===== Modul {__name__} ===== STOP')
