# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/64_PGM/64_PYT/m23a_LABC.py
"""
Definice demonstračních tříd k výkladu jednoduchého, lineárního dědění.
"""
from dbg import DBG
if DBG>0: print(f'===== Modul {__name__} ===== START')
############################################################################

class LA(object):     # Stejný význam má i hlavička: class LA:
    """Třída je bezprostředním potomkem třídy object."""
    cX = 'LA_csp'    # Třídní společný, používaný potomky
    cA = 'LA_cls'    # Třídní místní
    def __init__(self, id):
        self.ID = id          # Identifikátor dané instance
        self.iX = 'LA_isp'    # Instanční společný
        self.iA = 'LA_ins'    # Instanční místní
    def __repr__(self):
        return f"{self.__class__.__name__}_{self.ID}"
    def mtdA(self): return f"LA_inst({self})"
    def mtdv(self): return f"LA_virt({self})"

class LB(LA):
    """Třída je dcerou třídy LA => vnučkou třídy object."""
    cX = 'LB_csp'    # Třídní společný, definovaný rodičem
    cB = 'LB_cls'    # Třídní místní
    def __init__(self, id):
        super().__init__(id)
        self.iX = 'LB_isp'    # Atribut zděděný od rodiče
        self.iB = 'LB_ins'    # Instanční místní
    def mtdB(self): return f"LB_inst({self})"
    def mtdv(self): return f"LB_virt({self})"

class LC(LB):
    """Třída je dcerou třídy LB => vnučkou třídy LA
       => pravnučkou třídy object."""
    cX = 'LC_csp'    # Třídní společný, definovaný rodičem
    cC = 'LC_cls'    # Třídní místní
    def __init__(self, id):
        super().__init__(id)
        self.iX = 'LC_isp'    # Atribut zděděný od rodiče
        self.iC = 'LC_ins'    # Instanční místní
    def mtdC(self): return f"LC_inst({self})"
    def mtdv(self): return f"LC_virt({self})"


############################################################################
if DBG>0: print(f'===== Modul {__name__} ===== STOP')
