#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/64_PGM/64_PYT/m24__Násobné_dědění.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
24  Násobné dědění

Co se v kapitole naučíte
Tato kapitola vám vysvětlí, jak v Pythonu využívat násobné dědění a
jaká pravidla při jeho používání platí. Soustředí se přitom především
na pravidla vyhledání deklarovaného atributu v hierarchii předků.
Probere komolení jmen a na závěr představí návrhový vzor Šablonová metoda
a předvede jeho implementaci.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
from dbg import DBG
if DBG>0: print(f'===== Modul {__name__} ===== START')
############################################################################



#Výpis 24.1: Zdrojový kód tříd z modulu m24a_Diamant demonstrujících chování
#            diamantové architektury
############################################################################

""" Je uloženo v souboru m24a_Diamant.py. """



#Výpis 24.2: Prověrka vlastností násobného dědění
############################################################################
from m24a_Diamant import *
from utils import *
prseq(Dcera.__mro__)
# <class 'm24a_Diamant.Dcera'>
# <class 'm24a_Diamant.Matka1'>
# <class 'm24a_Diamant.Matka2'>
# <class 'm24a_Diamant.Babička'>
# <class 'object'>
d = Dcera()
# Dcera - START
# |  Matka1 - START
# |  |  Matka2 - START
# |  |  |  Babička - START
# |  |  |  Babička - KONEC - 1
# |  |  Matka2 - KONEC - 1
# |  Matka1 - KONEC - 1
# Dcera - KONEC - 1
d.__dict__
# {'ID': 1, 'iB': 'insBab', 'iM': 'insMa1', 'iD': 'insDcA'}
d.cM,   Dcera.cM,   Matka1.cM,   Matka2.cM
# ('clsMa1', 'clsMa1', 'clsMa1', 'clsMa2')
# >>>



#Výpis 24.3: Definice třídy Dcera2 v modulu m24a_Diamant
############################################################################

""" Je uloženo v souboru m24a_Diamant.py. """



#Výpis 24.4: Použití třídy Dcera2
############################################################################
dB = Dcera2()
# Dcera2 - START
# |  Matka1 - START
# |  |  Matka2 - START
# |  |  |  Babička - START
# |  |  |  Babička - KONEC - 2
# |  |  Matka2 - KONEC - 2
# |  Matka1 - KONEC - 2
# |  Matka2 - START
# |  |  Babička - START
# |  |  Babička - KONEC - 3
# |  Matka2 - KONEC - 3
# Dcera2 - KONEC - 3
dB.__dict__
# {'ID': 3, 'iB': 'insBab', 'iM': 'insMa2', 'iD': 'insDc2'}
dB.cM,   Dcera2.cM
# ('clsMa1', 'clsMa1')
# >>>



#Výpis 24.5: Definice modulu m24b_Argumenty s třídami používajícími násobné dědění
#            a konstruktory s parametry
############################################################################

""" Je uloženo v souboru m24b_Argumenty.py. """



#Výpis 24.6: Průběh inicializace instance třídy DceraA
############################################################################
from m24b_Arguments import DceraA
DceraA(arg_b='Bab', arg_m1='Ma1', arg_m2='Ma2', arg_d='Dce')
# DceraA - START
# arg_d='Dce', kwds={'arg_b': 'Bab', 'arg_m1': 'Ma1', 'arg_m2': 'Ma2'}
# |  MatkaA1 - START
# |  arg_m1='Ma1', kwds={'arg_b': 'Bab', 'arg_m2': 'Ma2'}
# |  |  MatkaA2 - START
# |  |  arg_m2='Ma2', kwds={'arg_b': 'Bab'}
# |  |  |  BabičkaA - START
# |  |  |  arg_b='Bab', kwds={}
# |  |  |  BabičkaA - KONEC - 1
# |  |  MatkaA2 - KONEC - 1
# |  MatkaA1 - KONEC - 1
# DceraA - KONEC - 1
# DceraA_1
# >>>



#Výpis 24.7: Nerealizovatelná a následně opravená hierarchie tříd
############################################################################
Ba1 = type('BabičkaA1', (),         {})
Ba2 = type('BabičkaA2', (),         {})
Ma1 = type('MatkaA1',   (Ba1, Ba2), {})
Ma2 = type('MatkaA2',   (Ba2, Ba1), {})
Da1 = type('DceraA1',   (Ma1, Ma2), {})
# Traceback (most recent call last):
#   File "<pyshell#15>", line 1, in <module>
#     Da1 = type('DceraA1',   (Ma1, Ma2), {})
# TypeError: Cannot create a consistent method resolution
# order (MRO) for bases BabičkaA1, BabičkaA2
Ma2 = type('MatkaA2',   (Ba1, Ba2), {})
Da1 = type('DceraA1',   (Ma1, Ma2), {})
prseq(Da1.__mro__)
# <class '__main__.DceraA1'>
# <class '__main__.MatkaA1'>
# <class '__main__.MatkaA2'>
# <class '__main__.BabičkaA1'>
# <class '__main__.BabičkaA2'>
# <class 'object'>
# >>>



#Výpis 24.8: Složitější hierarchie tříd
############################################################################
Bb1 = type('BabičkaB1', (),         {})
Bb2 = type('BabičkaB2', (),         {})
Bb3 = type('BabičkaB3', (),         {})
Mb1 = type('MatkaB1',   (Bb1, Bb2), {})
Mb2 = type('MatkaB2',   (Bb2, Bb3), {})
Db1 = type('DceraB1',   (Mb1, Mb2), {})
prseq(Db1.__mro__)
# <class '__main__.DceraB1'>
# <class '__main__.MatkaB1'>
# <class '__main__.BabičkaB1'>
# <class '__main__.MatkaB2'>
# <class '__main__.BabičkaB2'>
# <class '__main__.BabičkaB3'>
# <class 'object'>
# >>>



#Výpis 24.9: Pseudosoukromý atribut a komolení jmen
############################################################################
# >>> \
class Pseudo:
    __atr = 'Pseudosoukromý'
    _atr_ = 'Třídní'
    def pr1(): print(Pseudo.__atr)
    def pr2(): print(_atr_)
    def pr3(): print(__atr)

prdict(Pseudo)
# ##### Atributy objektu: <class '__main__.Pseudo'>
# _Pseudo__atr = Pseudosoukromý
# _atr_ = Třídní
# pr1 = <function Pseudo.pr1 at 0x00000219CE31C5E0>
# pr2 = <function Pseudo.pr2 at 0x00000219CE31C700>
# pr3 = <function Pseudo.pr3 at 0x00000219CE31C790>
_atr_ = 'Globální';    __atr = 'Neviditelný'
print(f'{_atr_=},  {__atr=}')
# _atr_='Globální',  __atr='Neviditelný'
Pseudo.pr1()
# Pseudosoukromý
Pseudo.pr2()
# Globální
Pseudo.pr3()
# Traceback (most recent call last):
#   File "<pyshell#41>", line 1, in <module>
#     Pseudo.pr3()
#   File "<pyshell#35>", line 7, in pr3
#     def pr3(): print(__atr)
# NameError: name '_Pseudo__atr' is not defined
# >>>



#Výpis 24.11: Definice tříd Bd a Md v modulu m24c_Komolení
############################################################################

""" Je uloženo v souboru m24c_Komolení.py. """



#Výpis 24.12: Použití tříd Bd a Md a jejich instancí
############################################################################
from m24c_Komolení import *
bd = Bd();   md = Md();   bd, md
# (Bd_1, Md_2)
md.tmpl()
# Soukr v Bd pro Md_2:
# self.__cpa='pr cls Bd', self.cpub='pu cls Md'
# self.__ipa='pr ins Bd', self.ipub='pu ins Md'
# Metoda v Md pro Md_2:
# self.__cpa='pr cls Md', self.cpub='pu cls Md'
# self.__ipa='pr ins Md', self.ipub='pu ins Md'
Bd._Bd__count = 10
bd = Bd();   md = Md();   bd, md
# (Bd_11, Md_12)
# >>>



#Výpis 24.Y: Popisek
############################################################################
if DBG>0: print(f'===== Modul {__name__} ===== STOP')
