#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/64_PGM/64_PYT/m25__Přetěžování_operátorů.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
25  Přetěžování operátorů.

Co se v kapitole naučíte
Kapitola vás seznámí s možnostmi rozšířit schopnosti instancí vaší třídy
o používání některých zabudovaných operátorů. Vysvětlí, jak se definuje
chování instancí při použití zadaného operátoru a jaké záludnosti
na vás mohou při snaze o implementaci některých z těchto metod čekat.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
from dbg import DBG
if DBG>0: print(f'===== Modul {__name__} ===== START')
############################################################################



#Výpis 25.1: Definice třídy Zlomek v modulu m25a_Zlomky
############################################################################

""" Je uloženo v souboru m25a_Zlomky.py. """



#Výpis 25.2: Práce s instancemi třídy Zlomek
############################################################################
from m25a_Zlomky import *
# ===== Modul dbg ===== START
# ===== Modul dbg ===== STOP
# ===== Modul m25a_Zlomky ===== START
# ===== Modul m25a_Zlomky ===== STOP
z63=Zlomek(16,3);  z84=Zlomek(8,4);  z12=Zlomek(1,2);   z63, z84, z12
# (Zlomek(5+1/3), Zlomek(2), Zlomek(1/2))
print(z12, f" -  for:{z12}  -  repr:{z12=}  -  for:{z12=:}")
# (1/2)Zlomek  -  for:(1/2)  -  repr:z12=Zlomek(1/2)  -  for:z12=(1/2)
f"#{z12:=^15}#"
# '#=====(1/2)=====#'
f"#{z12*z63=:*^15}#{z84+z12=:+^15}#"
# '#z12*z63=****(2+2/3)****#z84+z12=++++(2+1/2)++++#'
# >>>



#Výpis 25.3: Definice třídy Indexer přetěžující operátor []
############################################################################
# >>> \
class Indexer:
    def __getitem__(self, index):
        return index ** 2

x = Indexer();   x[3]
# 9
for i in range(5):   print(x[i], end=' - ')

# 0 - 1 - 4 - 9 - 16 -
# >>>



#Výpis 25.4: Přidání instanční metody pro konkrétní instanci
############################################################################
# >>> \
class instancemethod:
    """Převádí běžné funkce na instanční metody zadané instance."""
    def __init__(self, inst, fce):
        self.inst = inst    # Instance, pro níž balím funkci
        self.fce  = fce     # Funkce převáděná na instanční metodu
    def __call__(self, *args, **kwds):
        self.fce(self.inst, *args, **kwds)

def f1(self):   print(f"Instance třídy {self.__class__.__name__}")

def f2(self, a, b, c):   self.im1();   print(a, b, c)

class Test: pass

t = Test()
t.im1 = instancemethod(t, f1)
t.im2 = instancemethod(t, f2)
t.im2(10, 20, 30)
# Instance třídy Test
# 10 20 30
# >>>



#Výpis 25.5: Definice třídy C25a v modulu m25b_Atributy
############################################################################

""" Je uloženo v souboru m25b_Atributy.py. """



#Výpis 25.6: Ukázky reakcí na přístup k atributům ve třídě C25a
############################################################################
from m25b_Atributy import *
C25a.ca
# 'Class attr'
C25a.cb
# Traceback (most recent call last):
#   File "<pyshell#29>", line 1, in <module>
#     C25a.cb
# AttributeError: type object 'C25a' has no attribute 'cb'
c = C25a()
# __setattr__(self, name='ia', value='Inst attr')
# __getattribute__(self, name='__dict__')
# Spouštím: object.__getattribute__(self, name='__dict__')
# Následující kód bude vypadat divně - čtěte doprovodný text
# >>> __getattribute__(self, name='__dict__')
# Spouštím: object.__getattribute__(self, name='__dict__')
# __getattribute__(self, name='__class__')
# Spouštím: object.__getattribute__(self, name='__class__')
c.ca
# __getattribute__(self, name='ca')
# ca - atributy začínající 'c' jsou třídní =>
#      Volám C25a.__getattribute__(C25a, ca)
# 'Class attr'
c.ia
# __getattribute__(self, name='ia')
# Spouštím: object.__getattribute__(self, name='ia')
# 'Inst attr'
c.ib
# __getattribute__(self, name='ib')
# 'ib - Spočtený v _getattribute__()'
c.ic
# __getattribute__(self, name='ic')
# Spouštím: object.__getattribute__(self, name='ic')
# __getattr__(self, name='ic')
# 'ic - Spočtený v _getattr__()'
c.mtd()
# __getattribute__(self, name='mtd')
# Spouštím: object.__getattribute__(self, name='mtd')
# mtd - Instanční metoda třídy C25a
c.ia='Nová hodnota c.ia';   c.ia
# __setattr__(self, name='ia', value='Nová hodnota c.ia')
# __getattribute__(self, name='__dict__')
# Spouštím: object.__getattribute__(self, name='__dict__')
# __getattribute__(self, name='ia')
# Spouštím: object.__getattribute__(self, name='ia')
# 'Nová hodnota c.ia'
# >>>



#Výpis 25.7: Definice třídy C25b v modulu m25b_Atributy
############################################################################

""" Je uloženo v souboru m25b_Atributy.py. """



#Výpis 25.8: Práce s atributy instancí třídy C25b
############################################################################
cb = C25b()
cb.ix
# __getattr__(self, name='ix')
# 'Neexistující atribut: ix'
cb.const = 'Konstanta'
# __setattr__(self, name='const', value='Konstanta')
cb.const
# 'Konstanta'
cb.const = 'Změna'
# __setattr__(self, name='const', value='Změna')
# Traceback (most recent call last):
#   File "<pyshell#43>", line 1, in <module>
#     cb.const = 'Změna'
#   File "P:\64_PGM\64_PYT\m25b_Atributy.py", line 57, in __setattr__
#     raise ValueError("Hodnotu konstanty nelze měnit")
# ValueError: Hodnotu konstanty nelze měnit
del(cb.const)
# Traceback (most recent call last):
#   File "<pyshell#44>", line 1, in <module>
#     del(cb.const)
#   File "P:\64_PGM\64_PYT\m25b_Atributy.py", line 62, in __delattr__
#     raise ValueError(f"Konstantu {name} nelze smazat")
# ValueError: Konstantu const nelze smazat
# >>>



#Výpis 25.9: Demonstrace rozdílů v kódu při použití příkazu with
############################################################################
def print0(filename):
    """Vytiskne obsah souboru - verze nepoužívající příkaz with."""
    file = None
    try:
        file = open(filename)
        for line in file:
            print(line)
    except Exception as err:
        print(err)
    finally:
        if file is     not None:
            file.close()

def print1(filename):
    """Vytiskne obsah souboru s použitím příkazu with."""
    try:
        with open(filename) as file:
            for line in file:
                print(line)
    except Exception as err:
        print(err)



#Výpis 25.Y: Popisek
############################################################################
if DBG>0: print(f'===== Modul {__name__} ===== STOP')
