#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/64_PGM/64_PYT/m26__Dekorátory.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
26  Dekorátory.

Co se v kapitole naučíte
Kapitola vás seznámí s dekorátory, naučí vás používat existující dekorátory
a poté také definovat dekorátory vlastní.
Předvede rozdíly mezi dekorováním funkcí a tříd
a na závěr ještě stručně probere některé speciální možnosti.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
from dbg import DBG
if DBG>0: print(f'===== Modul {__name__} ===== START')
############################################################################



#Výpis 26.1: Definice třídy C26a a jejích metod využívajících dekorátorů
############################################################################
# >>> \
class C26a:
    """Demonstrace použití dekorátorů."""

    def inst(self): return f"{self.__class__.__name__}[{id(self):#_x}]"

    def class0(cls): return f"Metoda třídy {cls.__name__} - PO"
    class0 = classmethod(class0)

    @classmethod
    def class1(cls): return f"Metoda třídy {cls.__name__} - PŘED"

    def static0(): return 'Statická - PO'
    static0 = staticmethod(static0)

    @staticmethod
    def static1(): return 'Statická - PŘED'

c = C26a();   C26a.inst(c),   c.inst()
# ('C26a[0x1d0_7df1_bc40]', 'C26a[0x1d0_7df1_bc40]')
C26a().class0(),    c.class0()
# ('Metoda třídy C26a - PO', 'Metoda třídy C26a - PO')
C26a().class1(),    c.class1()
# ('Metoda třídy C26a - PŘED', 'Metoda třídy C26a - PŘED')
C26a().static0(),   c.static0()
# ('Statická - PO', 'Statická - PO')
C26a().static1(),   c.static1()
# ('Statická - PŘED', 'Statická - PŘED')
# >>>



#Výpis 26.2: Ukázka použití třídních metod
############################################################################
# >>> \
class Matka26a0:
    počet = 0
    @classmethod
    def další(cls, inc):   cls.počet += inc;   return cls.počet
    def __init__(self, inc=1):   self.ID=self.další(inc)
    def __repr__(self):   return f"{self.__class__.__name__}({self.ID})"

# >>> \
class Dcera26a1(Matka26a0):   # Přebíjí rodičovský initor
    počet = 0
    def __init__(self):   super().__init__(10);   self.ID += 1

# >>> \
class Dcera26a2(Matka26a0):   # Zdědí rodičovský initor
    počet = 0

Matka26a0(), Dcera26a1(), Dcera26a2(100)
# (Matka26a0(1), Dcera26a1(11), Dcera26a2(100))
Matka26a0(), Dcera26a1(), Dcera26a2(100)
# (Matka26a0(2), Dcera26a1(21), Dcera26a2(200))
Matka26a0(), Dcera26a1(), Dcera26a2(100)
# (Matka26a0(3), Dcera26a1(31), Dcera26a2(300))
# >>>



#Výpis 26.3: Ukázka definice tovární metody
############################################################################
# >>> \
class Osoba:
    def __init__(self, křestní=None, příjmení=None):
        """Initor volaný standardním konstruktorem."""
        self.křestní  = křestní
        self.příjmení = příjmení

    @classmethod
    def jméno(cls, celé):
        """Tovární metoda pro alternativní argumenty."""
        jméno=celé.split()
        return cls(jméno[0], jméno[1])

    def __repr__(self):
        křestní  = self.křestní
        příjmení = self.příjmení
        return f'Osoba({křestní=}, {příjmení=})'

Osoba('Tomáš', 'Marný')
# Osoba(křestní='Tomáš', příjmení='Marný')
Osoba.jméno('Jana Vdaná')
# Osoba(křestní='Jana', příjmení='Vdaná')
# >>>



#Výpis 26.4: Definice dekorátoru – třídy traced v modulu m26a_Traced
############################################################################

""" Je uloženo v souboru m26a_Traced.py. """



#Výpis 26.5: Použití dekorátoru traced
############################################################################
from m26a_Traced import traced
@traced
def test(n):
    import utils
    utils.factR = traced(utils.factR)
    utils.factR(n)

test(3)
# >> test((3,))
#    >> factR((3,))
#       >> factR((2,))
#          >> factR((1,))
#          << factR=1
#       << factR=2
#    << factR=6
# << test=None
test(1)
# >> test((1,))
# fce=<m26a_Traced.traced object at 0x000001D07DF490A0>
#    >> factR((1,))
#    << factR=1
# << test=None
test
# <m26a_Traced.traced object at 0x000001D07DF28EE0>
# >>>



#Výpis 26.6: Definice dekorátorů jedináčka v modulu m26b_Singleton
############################################################################

""" Je uloženo v souboru m26b_Singleton.py. """



#Výpis 26.7: Použití dekorátoru singleton
############################################################################
from m26b_Singleton import *
# >>> \
@singleton
class STest:
    count = 0
    def __init__(self):
        # STest.count+=1
        # self.ID=f'STest_{STest.count}'
        self.__class__.count += 1
        self.ID = f'STest_{self.__class__.count}'
    def __repr__(self):   return self.ID

STest(), STest(), STest()
# (STest_1, STest_1, STest_1)
# >>>



#Výpis 26.8: Definice datové třídy a její test
############################################################################
from dataclasses import dataclass
from typing      import ClassVar
# >>> \
@dataclass
class Položka:
    """Instance reprezentují položky na skladě."""
    název:    str
    cena:     float
    množství: int = 0
    pořadí:   ClassVar[int] = 0

    def __post_init__(self):
        Položka.pořadí += 1
        self.ID = Položka.pořadí

    def celkem(self) -> float:
        """Vrátí cenu uskladněných odpovídajících výrobků."""
        return self.cena * self.množství

from utils import prdict
prdict(Položka)
# ##### Atributy objektu: <class '__main__.Položka'>
# množství = 0
# pořadí = 0
# celkem = <function Položka.celkem at 0x0000021B035D0280>
prdict(p := Položka("Máslo", 29, 5))
# ##### Atributy objektu: Položka(název='Máslo', cena=29, množství=5)
# název = Máslo
# cena = 29
# množství = 5
# ID = 1
# >>>



#Výpis 26.Y: Popisek
############################################################################
if DBG>0: print(f'===== Modul {__name__} ===== STOP')
