#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/64_PGM/64_PYT/m29__Generátory_a_iterátory.py
"""
Zadávané příkazy a záznamy odpovědí uvedené ve výpisech kapitoly
29  Generátory a iterátory.
"""
from dbg import DBG
if DBG>0: print(f'===== Modul {__name__} ===== START')
############################################################################



#Výpis 29.1: Demonstrace funkce generátorů
############################################################################
# >>> \
def gen_fce():
    """Demonstrace fungování generátoru."""
    x = 0; y=7
    while y:
        print(str(x:=x+1) + '. běh: ', end='')
        print(f'Minule: {x=}, {y=}, Nyní:', (y := (yield f'{y*y=}')))
    print('konec')

def pr(x):
    """Pomocná funkce pro kontrolní tisky."""
    print(f'Dodáno: {x},  Obdrženo: {gen_iter.send(x)}')

gen_iter = gen_fce() # Zavolání generátorové funkce vytvoří generátor
gen_iter.send(99)    # Chyba - žádný yield se ještě nevyhodnocoval
# Traceback (most recent call last):
#   File "<pyshell#3>", line 1, in <module>
#     gen_iter.send(99)    # Chyba - žádný yield se ještě nevyhodnocoval
# TypeError: can't send non-None value to a just-started generator
next(gen_iter)  # Tímto se generátor odstartuje
# 1. běh: 'y*y=49'
pr(9)           # Nyní mu již můžeme posílat hodnoty
# Minule: x=1, y=7, Nyní: 9
# 2. běh: Dodáno: 9,  Obdrženo: y*y=81
pr(8)
# Minule: x=2, y=9, Nyní: 8
# 3. běh: Dodáno: 8,  Obdrženo: y*y=64
next(gen_iter)
# Minule: x=3, y=8, Nyní: None
# konec
# Traceback (most recent call last):
#   File "<pyshell#7>", line 1, in <module>
#     next(gen_iter)
# StopIteration
# >>>



#Výpis 29.2: Demonstrační příklad použití výrazu yield
############################################################################
# >>> \
def cyklus(stop: int):
    """Funkce ovlivňující hodnoty parametru cyklu for."""
    for x in (gen_iter:=gen()):
        print(x, '-', end=' ')  # Standardní činnost v těle cyklu
        if not x % 3:           # Přenastavení parametru cyklu
            x = gen_iter.send(1 if x<stop else -1)
            print(x, '#')  # Použití falešného parametru

# >>> \
def gen():
    """Definice generátorové funkce reagující na vstupy."""
    k = 1   # Proměnná definující přírůstek hodnot parametru cyklu
    i = 1   # Hodnota parametru cyklu předávaná volající funkci
    while True:
        multi = yield i # Zde se činnost přerušuje a opět navazuje
        if k == 0:      # V minulém běhu bylo nastaveno ukončení
            return      #==========>
        elif multi == None: # Normální průběh
            i += k          # Inkrementace parametru cyklu pro příště
        elif multi > 0:     # Budeme zvětšovat hodnotu přírůstku
            k *= 10
            i = 0           # Falešná hodnota vracená při nastavování
        elif multi < 0:     # Příště budeme končit
            k = i = 0       # Příznak ukončení plus falešná hodnota
        else:
            raise RuntimeError('Špatná hodnota')

cyklus()
# 1 - 2 - 3 - 0 #
# 10 - 20 - 30 - 0 #
# 100 - 200 - 300 - 0 #
# >>>



#Výpis 29.3: Definice generátorových funkcí gen2() a gen21 demonstrující
#            použití výrazu yield from
############################################################################
# >>> \
def gen2(x, y):
    """Generátorová funkce využívající výrazy/příkazy yield from."""
    for n in range(x, x+y):
        y = yield from gen21(n)
        print ('from[', str(y), sep='', end=']')
        y = yield '# '
        print (' {', y, end=' }\n')

# >>> \
def gen21(n):
    """Postupně poskytne první tři mocniny svého argumentu."""
    for x in range (1, 4):
        yield n
        n *= n

for i in gen2(5, 3): print(i, end='-')

# 5-25-625-from[None]# - { None }
# 6-36-1296-from[None]# - { None }
# 7-49-2401-from[None]# - { None }
# >>>



#Výpis 29.Y: Popisek
############################################################################
if DBG>0: print(f'===== Modul {__name__} ===== STOP')
