#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/64_PGM/64_PYT/m30__Metatřídy.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
29  Ovlivnění tvorby tříd, metatřídy.

Co se v kapitole naučíte
Kapitola vás seznámí s metatřídami, což jsou objekty umožňující ovlivnit
způsob, jak budou definovány třídy. Nejprve předvede,
jak se prostřednictvím metatřídy definují abstraktní třídy.
Pak vysvětlí, jak může rodičovská třída ovlivnit vytváření svých potomků,
a na závěr vás naučí vytvářet vlastní metatřídy různých druhů.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
from dbg import DBG
if DBG>0: print(f'===== Modul {__name__} ===== START')
############################################################################



#Výpis 30.1: Použití metody __init_subclass__()
############################################################################
# >>> \
class C30a:
    """Třída ovlivňující definice svých potomků."""
    _podtříd = 0
    def __init_subclass__(cls, **kwds):
        super().__init_subclass__(**kwds)
        C30a._podtříd += 1    # Inkrementuje počet vytvořených potomků
        cls._instancí =  0    # Definuj třídní atribut potomka
        cls.cid = C30a._podtříd   # Potomek si pamatuje své rodné číslo
        cls.__repr__ = lambda self: f"{cls.__name__}({self.id})"
    def __init__(self):
        # Inkrementuje počet vytvořených instancí potomka
        self.__class__._instancí += 1
        # Definuje rodné číslo instance potomka
        self.id = f'{self.cid}-{self._instancí}'

# >>> \
class C30a1(C30a):
    def __init__(self):
        super(C30a1, self).__init__()

# >>> \
class C30a2(C30a):
    def __init__(self):
        super().__init__()

C30a1(),   C30a1(),   C30a2(),   C30a1(),   C30a2()
# (C30a1(1-1), C30a1(1-2), C30a2(2-1), C30a1(1-3), C30a2(2-2))
# >>>



#Výpis 30.2: Definice abstraktní třídy a jejího potomka
############################################################################
from abc import ABCMeta, abstractmethod
# >>> \
class Matka30a(metaclass=ABCMeta):
    def template(self):
        print('Matka30a.template - spouštím metodu action')
        self.action()
        print('Matka30a.template - metoda action ukončena')
    @abstractmethod
    def action(self):   pass

Matka30a()
# Traceback (most recent call last):
#   File "<pyshell#2>", line 1, in <module>
#     Matka30a()
# TypeError: Can't instantiate abstract class Matka30a with abstract method action
# >>> \
class Dcera30a(Matka30a):
    def action(self):   print("---Spuštěna metoda Dcera30a.action")

da = Dcera30a()
da.template()
# Matka30a.template - spouštím metodu action
# ---Spuštěna metoda Dcera30a.action
# Matka30a.template - metoda action ukončena
# >>>



#Výpis 30.3: Šablona testu funkce metatřídy v modulu m30a_TestMetaXxx
############################################################################

""" Je uloženo v souboru m30a_TestMetaXxx.py. """



#Výpis 30.4: Import modulu m30a_TestMetaXxx
############################################################################
import m30a_TestMetaXxx
# ===== Vytvářím třídu =====
# Tělo definované třídy Dcera30Xxx spuštěno:
# Tělo definované třídy Dcera30Xxx ukončeno
# ===== Vytvářím instanci =====
# df.data='Fce', df.mtd(1)='Fce(1)',
# type(Dcera30Xxx)=<class 'type'>
# >>>



#Výpis 30.5: Definice metatřídy MetaFce definované jako funkce
############################################################################

""" Je uloženo v souboru m30b_MetaFce.py. """



#Výpis 30.6: Import modulu m30b_MetaFce
############################################################################
import m30b_MetaFce
# ===== Vytvářím třídu =====
# MetaFce.__prepare__:
# ...classname='Dcera30Fce'
# ...supers=(<class 'm30b_MetaFce.Matka30Fce'>,)
# ...Vracím slovník DICT={'da': 'MF', 'fa': <function __prepare__.<locals>.<lambda> at 0x000002A269844820>}
# Tělo definované třídy Dcera30Fce spuštěno:
# Tělo definované třídy Dcera30Fce ukončeno
# MetaFce:
# ...classname='Dcera30Fce'
# ...supers=(<class 'm30b_MetaFce.Matka30Fce'>,)
# ...['da', 'fa', '__module__', '__qualname__', '__doc__', 'data', 'mtd']
# ...Vytvořena a inicializována třída <class 'm30b_MetaFce.Dcera30Fce'>
# ===== Vytvářím instanci =====
# df.data='Fce', df.mtd(1)='Fce(1)', df.da='MF'
# df.fa()='<m30b_MetaFce.Dcera30Fce object at 0x000001FBA9AF08E0>'
# type(Dcera30Fce)=<class 'type'>
# >>>



#Výpis 30.7: Definice metatřídy MetaCls definované jako třída
############################################################################

""" Je uloženo v souboru m30c_MetaCls.py. """



#Výpis 30.8: Import modulu m30c_MetaCls
############################################################################
import m30c_MetaCls
# ===== Vytvářím třídu =====
# MetaCls.__prepare__:
# ...classname='Dcera30Cls'
# ...supers=(<class 'm30c_MetaCls.Matka30Cls'>,)
# ...Vracím slovník DICT={'Mcls': 'MC'}
# Tělo definované třídy Dcera30Cls spuštěno:
# Tělo definované třídy Dcera30Cls ukončeno
# MetaCls.__new__:
# ...meta=<class 'm30c_MetaCls.MetaCls'>
# ...classname='Dcera30Cls'
# ...supers=(<class 'm30c_MetaCls.Matka30Cls'>,)
# ...['Mcls', '__module__', '__qualname__', '__doc__', 'data', 'mtd']
# ...Vytvořena třída <class 'm30c_MetaCls.Dcera30Cls'>
# MetaCls.__init__:
# ...classname='Dcera30Cls'
# ...supers=(<class 'm30c_MetaCls.Matka30Cls'>,)
# ...['Mcls', '__module__', '__qualname__', '__doc__', 'data', 'mtd']
# ...Inicializována třída <class 'm30c_MetaCls.Dcera30Cls'>
# ===== Vytvářím instanci =====
# dc.data='Cls', dc.mtd(1)='Cls(1)', dc.da='MF'
# dc.fa()='<m30c_MetaCls.Dcera30Cls object at 0x0000015725A2E700>'
# type(Dcera30Cls)=<class 'm30c_MetaCls.MetaCls'>
# >>>



#Výpis 30.9: Definice metatřídy MetaObj definované jako objekt
############################################################################

""" Je uloženo v souboru m30d_MetaObj.py. """



#Výpis 30.10: Import modulu m30d_MetaObj
############################################################################
import m30d_MetaObj
# ===== Vytvářím třídu =====
# MetaObj.__prepare__:
# ...self=<m30d_MetaObj.MetaObj object at 0x000001A6DED4D220>
# ...classname='Dcera30Obj'
# ...supers=(<class 'm30d_MetaObj.Matka30Obj'>,)
# ...Vracím slovník DICT={'da': 'MF', 'fa': <function MetaObj.__prepare__.<locals>.<lambda> at 0x000002A0F48668B0>}
# Tělo definované třídy Dcera30Obj spuštěno:
# Tělo definované třídy Dcera30Obj ukončeno
# MetaObj.__call__:
# ...self=<m30d_MetaObj.MetaObj object at 0x000001A6DED4D220>
# ...classname='Dcera30Obj'
# ...supers=(<class 'm30d_MetaObj.Matka30Obj'>,)
# ...['da', 'fa', '__module__', '__qualname__', '__doc__', 'data', 'mtd']
# ...MetaObj.__new__:
# ......self=<m30d_MetaObj.MetaObj object at 0x000001A6DED4D220>
# ......classname='Dcera30Obj'
# ......supers=(<class 'm30d_MetaObj.Matka30Obj'>,)
# ......['da', 'fa', '__module__', '__qualname__', '__doc__', 'data', 'mtd']
# ......Vytvořena třída CLASS=<class 'm30d_MetaObj.Dcera30Obj'>
# ...MetaObj.__init__:
# ......self=<m30d_MetaObj.MetaObj object at 0x000001A6DED4D220>
# ......classname='Dcera30Obj'
# ......supers=(<class 'm30d_MetaObj.Matka30Obj'>,)
# ......['da', 'fa', '__module__', '__qualname__', '__doc__', 'data', 'mtd']
# ......Inicializována třída CLASS=<class 'm30d_MetaObj.Dcera30Obj'>
# Konec práce MetaObj.call
# ===== Vytvářím instanci =====
# do.data='Cls', do.mtd(1)='Cls(1)', do.da='MF'
# do.fa()='<m30d_MetaObj.Dcera30Obj object at 0x000001A6DED4D220>'
# type(Dcera30Obj)=<class 'type'>
# >>>



#Výpis 30.11: Definice jedináčka pomocí __new__()
############################################################################
# >>> \
class Singleton30new:
    __instance = None
    def __new__ (cls) :
        if(cls.__instance == None) :
            cls.__instance = object.__new__(cls)
        return cls. __instance
    def __init__(self):
        print(f'Volána metoda __init__()')

print(s1:=Singleton30new(), s2:=Singleton30new(), s1 is s2, sep= '\n')
# Volána metoda __init__()
# Volána metoda __init__()
# <__main__.Singleton30new object at 0x00000254C0F051F0>
# <__main__.Singleton30new object at 0x00000254C0F051F0>
# True
# >>>



#Výpis 30.12: Definice jedináčka pomocí metatřídy
############################################################################
# >>> \
class MetaSingleton(type):
    __instance = None
    def  __call__(self):
        if (self.__instance == None):
            self.__instance = self.__new__(self)
            self.__init__(self.__instance)
        return self.__instance

# >>> \
class Singleton(metaclass=MetaSingleton):
    def  __init__(self):
        print(f'Volána metoda __init__()')

print(s1 := Singleton(), s2 := Singleton(), s1 is s2, sep='\n')
# Volána metoda __init__()
# <__main__.Singleton object at 0x00000254C0F05550>
# <__main__.Singleton object at 0x00000254C0F05550>
# True
# >>>



#Výpis 30.Y: Popisek
############################################################################
if DBG>0: print(f'===== Modul {__name__} ===== STOP')
