#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/64_PGM/64_PYT/m31__Korutiny_vlákna_procesy.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
30  Korutiny, vlákna, procesy.

Co se v kapitole naučíte
Tato kapitola probírá další z témat, která by vydala na samostatnou publikaci.
Ukáže vám, jak je v Pythonu možné naprogramovat paralelní běh více činností.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
from dbg import DBG
if DBG>0: print(f'===== Modul {__name__} ===== START')
############################################################################



#Výpis 31.1: Definice a použití jednoduchých korutin
############################################################################
import asyncio
import time
# >>> \
async def say_after(delay, what):
    print(f"Spuštěno v {time.strftime('%X')}: {delay=}, {what=}")
    await asyncio.sleep(delay)
    print(f"Tištěno v {time.strftime('%X')}: {what=}")

# >>> \
async def await31():
    print(f"await31: Start v {time.strftime('%X')}")
    await say_after(2, 'Dva')
    print(f"await31: Mezičas: {time.strftime('%X')}")
    await say_after(1, 'Raz')
    print(f"await31: Konec v {time.strftime('%X')}")

asyncio.run(await31())
# await31: Start v 17:26:18
# Spuštěno v 17:26:18: delay=2, what='Dva'
# Tištěno v 17:26:20: what='Dva'
# await31: Mezičas: 17:26:20
# Spuštěno v 17:26:20: delay=1, what='Raz'
# Tištěno v 17:26:21: what='Raz'
# await31: Konec v 17:26:21
# >>>



#Výpis 31.2: Zabalení korutiny do instance třídy Task
############################################################################
# >>> \
async def task31():
    task2 = asyncio.create_task(say_after(2, 'Dva'))
    print('Mezi vytvořením task2 a task1')
    task1 = asyncio.create_task(say_after(1, 'Raz'))
    await asyncio.sleep(1)
    print(f"task31: Start v {time.strftime('%X')}")
    await task2
    print(f"task31: Mezičas: {time.strftime('%X')}")
    await task1
    print(f"task31: Konec v {time.strftime('%X')}")

asyncio.run(task31())
# Mezi vytvořením task2 a task1
# Spuštěno v 17:27:37: delay=2, what='Dva'
# Spuštěno v 17:27:37: delay=1, what='Raz'
# task31: Start v 17:27:38
# Tištěno v 17:27:38: what='Raz'
# Tištěno v 17:27:39: what='Dva'
# task31: Mezičas: 17:27:39
# task31: Konec v 17:27:39
# >>>



#Výpis 31.3: Analýza datových typů
############################################################################
type(say_after), type(await31), type(task31)
# (<class 'function'>, <class 'function'>, <class 'function'>)
type(say_after(0, "")), type(await31()), type(task31())

# Warning (from warnings module):
#   File "<pyshell#10>", line 1
# RuntimeWarning: coroutine 'say_after' was never awaited
#
# Warning (from warnings module):
#   File "<pyshell#10>", line 1
# RuntimeWarning: coroutine 'await31' was never awaited
#
# Warning (from warnings module):
#   File "<pyshell#10>", line 1
# RuntimeWarning: coroutine 'task31' was never awaited
# (<class 'coroutine'>, <class 'coroutine'>, <class 'coroutine'>)
type(say_after(0, "")), type(await31()), type(task31())
# (<class 'coroutine'>, <class 'coroutine'>, <class 'coroutine'>)
# >>>



#Výpis 31.Y: Popisek
############################################################################
if DBG>0: print(f'===== Modul {__name__} ===== STOP')
