#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/utils.py
"""
Sada několika demonstračních generátorových funkcí pro použití v ukázkách.
Dokumentační komentář modulu.
"""
from dbg import DBG
if DBG>0: print(f'===== Modul {__name__} ===== START')
############################################################################


def factR(n):
    """Rekurzivní definice faktoriálu."""
    if n<=1 : return 1
    return n * factR(n-1)


def gen2(n: int):
    """Generátor prvních n násobků čísla 11.
    """
    for x in range(11, n*11+1, 11):
        yield x


def gen3(n: int):
    """Generátor prvních n násobků čísla 111.
    """
    for x in range(111, n*111+1, 111):
        yield x


def gen_str(n: int):
    """Generátor n slovních názvů čísel, mazimálně však 5.
    """
    str = ('Raz', 'Dva', 'Tři', 'Čty', 'Pět')
    for x in range(1, n+1):
        yield str[x]


def gen_square(n: int, start: int = 1):
    """Generátor druhých mocnin přirozených čísel
       počínaje číslem start a konče číslem n včetně.
    """
    for x in range(start, n+1):    # Včetně n^2
        yield x*x


def gen_geom(n: int, quotient: float, start: float = 1.):
    """Generátor vracející n členů geometrické řady s kvocientem quotient
       počínaje členem start.
    """
    if n < 1:
        print("geom -- požadován argument >= 1")
        return
    for i in range(1, n+1):
        yield start
        start *= quotient
    return


def gen_fibonacci(n: int):
    """Generátor vracející členy Fibonacciho posloupnosti od 1. do n-tého.
       Argument musí být >= 1;
    """
    n2 = 0  # Hodnota položky n-2
    n1 = 1  # Hodnota položky n-1
    if n < 1:
        print("fibonacci -- požadován argument >= 1")
        return
    for i in range(1, n+1):
        n2, n1 = n1, n2 + n1
        yield (i, n1)
    return


def prdict(d, dict=False, syst=False, msg=''):
    """Vytiskne položky jmenného prostoru zadané instance,
       každou na samostatný řádek.
       dict - True oznamuje, že je zadán slovník, False běžný objekt
       syst - budou-li se tisknout i systémové položky.
    """
    if (dict):
        dd = d;
        t  = 'Obsah slovníku'
    else:
        dd = d.__dict__;
        t  = 'Atributy objektu'
        if msg=='':  msg = str(d)
    print(f'##### {t}: {msg}')
    for k, v in dd.items():
        if (syst  or  not k.startswith('__')):
            print(f"{k} = {v}")


# def prdict(d, dict=False, syst=False):
#     """Vytiskne položky jmenného prostoru zadané instance,
#        každou na samostatný řádek.
#        Argument syst zadává, zda se budou tisknout i systémové položky.
#     """
#     print("##### Atributy objektu", d)
#     for k, v in d.__dict__.items():
#         if (syst  or  not k.startswith('__')):
#             print(f"{k} = {v}")


# def prSE(cls, sk, msg='') -> str:
#     """Vytiskne oznámení o startu, resp, konci provádění volající metody.
#        cls = třída, jejíž metoda tuto metodu volá
#        se  = příznak tisku startu (True) či ukončení (False) těla metody
#        msg = Případná zpráva za vlastním oznámením
#        Vrací doporučené odsazení pro následující tisky
#     """
#     if not sk: prSE.level -= 1  # Trasovaná metoda končí, zmenšuji odsazení
#     print(f'{prSE.level * prSE.sp}{cls.__name__} - ' +
#           f'{"START" if sk else "KONEC"}' +
#           f'{"" if msg == "" else f" - {msg}"}')
#     if sk: prSE.level += 1  # Zvětšuji odsazení pro nižší hladinu
#     return prSE.level * prSE.sp
# prSE.level = 0      # Hladina vnoření pro nastavení odsazení
# prSE.sp = '   '     # Text odsazení pro znázornění hladiny volání


def prSE(obj, is_start, msg='') -> str:
    """Vytiskne oznámení o startu, resp. konci kódu volatelného objektu.
       obj = pojmenovaný objekt, jehož název indikuje, co voláme
       is_start = příznak startu (True) či konce (False) indikovaného kódu
       msg = Případná zpráva za vlastním oznámením
       Vrací string s doporučeným odsazovacím stringem pro následující tisky
    """
    if not is_start: prSE.level -= 1    # Kód končí, zmenšuji odsazení
    indent = prSE.level * prSE.str_1    # Odsazovací string
    print(f'{indent}{obj.__name__} - '
          f'{"START" if is_start else "KONEC"}'
          f'{f" - {msg}" if msg != "" else ""}')
    if is_start: prSE.level += 1  # Zvětšuji odsazení pro nižší hladinu
    return indent
prSE.level = 0      # Hladina vnoření pro nastavení odsazení
prSE.str_1 = '|  '  # Text jednoho odsazení pro znázornění hladiny volání


def prseq(seq):
    """Vytiskne položky zadané posloupnosti, každou na samostatný řádek."""
    for x in seq: print(x)



############################################################################
if DBG>0: print(f'===== Modul {__name__} ===== STOP')
